import React__default, { useState, useEffect, Fragment, createContext, useContext, useRef, forwardRef, createElement, useImperativeHandle } from 'react';
import { Skeleton, Space, Tag, Image, Input } from 'antd';
import moment from 'moment';
import 'react-is';
import 's-platform/dist/index.css';

var styles = {"test":"_3ybTi"};

var CONVERSATION_TYPE = {
  MESSENGER: 'messenger',
  ZALO: 'zalo'
};
var CONST = {
  CONVERSATION_TYPE: CONVERSATION_TYPE,
  EVENT: {
    WEBHOOK_FACEBOOK: 'webhook_facebook',
    WEBHOOK_ZALO: 'webhook_zalo'
  }
};

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}

var FbConversations = function FbConversations(props) {
  var shopId = props.shopId,
    pageId = props.pageId,
    _props$indexDefault = props.indexDefault,
    indexDefault = _props$indexDefault === void 0 ? 0 : _props$indexDefault,
    _props$actionGetFbCon = props.actionGetFbConversations,
    actionGetFbConversations = _props$actionGetFbCon === void 0 ? function () {} : _props$actionGetFbCon,
    _props$onSelectConver = props.onSelectConversation,
    onSelectConversation = _props$onSelectConver === void 0 ? function () {} : _props$onSelectConver,
    _props$fetchingDone = props.fetchingDone,
    fetchingDone = _props$fetchingDone === void 0 ? function () {} : _props$fetchingDone,
    _props$tags = props.tags,
    tags = _props$tags === void 0 ? {} : _props$tags,
    _props$socket = props.socket,
    socket = _props$socket === void 0 ? null : _props$socket;
  var _useState = useState(true),
    fetchingConversations = _useState[0],
    setFetchingConversations = _useState[1];
  var _useState2 = useState(false),
    loadConversations = _useState2[0],
    setLoadConversations = _useState2[1];
  var _useState3 = useState();
  var _useState4 = useState(),
    conversation = _useState4[0],
    setConversation = _useState4[1];
  var _useState5 = useState([]),
    conversations = _useState5[0],
    setConversations = _useState5[1];
  var _useState6 = useState(true),
    isNextPageConversations = _useState6[0];
  var _useState7 = useState({
      shopId: shopId,
      page: 0,
      pageSize: 10
    }),
    conversationsParams = _useState7[0],
    setConversationsParams = _useState7[1];
  useEffect(function () {
    getListConversation();
  }, [pageId]);
  useEffect(function () {}, [socket]);
  var getListConversation = function getListConversation() {
    try {
      if (!pageId) return Promise.resolve();
      setLoadConversations(true);
      setFetchingConversations(true);
      return Promise.resolve(actionGetFbConversations(shopId, pageId)).then(function (res) {
        var _res$data, _res$data$data;
        console.log('actionGetFbConversations', res);
        var resDatas = (res === null || res === void 0 ? void 0 : (_res$data = res.data) === null || _res$data === void 0 ? void 0 : (_res$data$data = _res$data.data) === null || _res$data$data === void 0 ? void 0 : _res$data$data.data) || [];
        var _conversations = [];
        resDatas.forEach(function (e) {
          var _e$participants, _e$participants$data, _e$messages, _e$messages$data, _e$messages$data$;
          var partner = e === null || e === void 0 ? void 0 : (_e$participants = e.participants) === null || _e$participants === void 0 ? void 0 : (_e$participants$data = _e$participants.data) === null || _e$participants$data === void 0 ? void 0 : _e$participants$data[0];
          var displayName = (partner === null || partner === void 0 ? void 0 : partner.name) || '';
          var displayAvatar = (partner === null || partner === void 0 ? void 0 : partner.urlAvatar) || '';
          var fbChatUserId = (partner === null || partner === void 0 ? void 0 : partner.id) || '';
          var chatId = (e === null || e === void 0 ? void 0 : e.id) || '';
          var message = (e === null || e === void 0 ? void 0 : (_e$messages = e.messages) === null || _e$messages === void 0 ? void 0 : (_e$messages$data = _e$messages.data) === null || _e$messages$data === void 0 ? void 0 : (_e$messages$data$ = _e$messages$data[0]) === null || _e$messages$data$ === void 0 ? void 0 : _e$messages$data$.message) || '';
          _conversations.push({
            displayName: displayName,
            displayAvatar: displayAvatar,
            message: message,
            time: (e === null || e === void 0 ? void 0 : e.updated_time) || 0,
            chatId: chatId,
            fbChatUserId: fbChatUserId
          });
        });
        setConversations(_conversations);
        setLoadConversations(false);
        setFetchingConversations(false);
        selectConversation(_conversations === null || _conversations === void 0 ? void 0 : _conversations[indexDefault]);
        fetchingDone(_conversations);
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var selectConversation = function selectConversation(_conversation) {
    console.log('_conversation', _conversation);
    if ((_conversation === null || _conversation === void 0 ? void 0 : _conversation.chatId) !== (conversation === null || conversation === void 0 ? void 0 : conversation.chatId)) {
      setConversation(_conversation);
      onSelectConversation(_conversation);
    }
  };
  var handleScroll = function handleScroll(event) {
    var scrollTop = event.currentTarget.scrollTop;
    var scrollHeight = event.currentTarget.scrollHeight;
    var offsetHeight = event.currentTarget.offsetHeight;
    var scrollBottom = scrollHeight - offsetHeight - scrollTop;
    if (scrollBottom < 50 && !loadConversations) {
      console.log('bottom');
      if (isNextPageConversations) {
        setConversationsParams(_extends({}, conversationsParams, {
          page: conversationsParams.page + 1
        }));
      }
    }
  };
  return fetchingConversations ? /*#__PURE__*/React__default.createElement("div", {
    style: {
      padding: 24
    }
  }, /*#__PURE__*/React__default.createElement(Skeleton, {
    loading: true,
    active: true,
    avatar: true
  }), /*#__PURE__*/React__default.createElement(Skeleton, {
    loading: true,
    active: true,
    avatar: true
  }), /*#__PURE__*/React__default.createElement(Skeleton, {
    loading: true,
    active: true,
    avatar: true
  })) : /*#__PURE__*/React__default.createElement("div", {
    onScroll: handleScroll,
    style: {
      display: 'flex',
      flexFlow: 'column',
      overflowY: 'auto',
      marginLeft: 12,
      marginTop: 12
    }
  }, conversations === null || conversations === void 0 ? void 0 : conversations.map(function (e, i) {
    var _moment$fromNow, _moment$fromNow$repla, _tags$e$chatId;
    return /*#__PURE__*/React__default.createElement("div", {
      style: {
        display: 'inline-flex',
        padding: 12,
        cursor: 'pointer',
        borderRadius: 6,
        marginRight: 6,
        backgroundColor: (e === null || e === void 0 ? void 0 : e.chatId) === (conversation === null || conversation === void 0 ? void 0 : conversation.chatId) ? '#f1f1f1' : 'transparent'
      },
      onClick: function onClick() {
        return selectConversation(e);
      },
      key: i
    }, /*#__PURE__*/React__default.createElement("img", {
      src: e === null || e === void 0 ? void 0 : e.displayAvatar,
      style: {
        width: 40,
        height: 40,
        borderRadius: 20,
        objectFit: 'cover',
        backgroundColor: '#f1f1f1'
      }
    }), /*#__PURE__*/React__default.createElement("div", {
      style: {
        marginLeft: 12
      }
    }, /*#__PURE__*/React__default.createElement("div", null, e === null || e === void 0 ? void 0 : e.displayName), /*#__PURE__*/React__default.createElement("div", {
      style: {
        display: 'flex',
        flexDirection: 'row',
        alignItems: 'center',
        fontSize: 12,
        color: '#999',
        marginTop: 2
      }
    }, e !== null && e !== void 0 && e.message ? /*#__PURE__*/React__default.createElement(Fragment, null, /*#__PURE__*/React__default.createElement("div", {
      style: {
        maxWidth: 120,
        'white-space': 'nowrap',
        'text-overflow': 'ellipsis',
        overflow: 'hidden'
      }
    }, e === null || e === void 0 ? void 0 : e.message), /*#__PURE__*/React__default.createElement("div", {
      style: {
        width: 2,
        height: 2,
        backgroundColor: '#ccc',
        borderRadius: 2,
        margin: '0px 4px'
      }
    })) : null, /*#__PURE__*/React__default.createElement("div", null, (_moment$fromNow = moment(e === null || e === void 0 ? void 0 : e.time).fromNow()) === null || _moment$fromNow === void 0 ? void 0 : (_moment$fromNow$repla = _moment$fromNow.replace('trước', '')) === null || _moment$fromNow$repla === void 0 ? void 0 : _moment$fromNow$repla.trim())), /*#__PURE__*/React__default.createElement(Space, {
      size: 0,
      style: {
        marginTop: 4
      }
    }, tags === null || tags === void 0 ? void 0 : (_tags$e$chatId = tags[e === null || e === void 0 ? void 0 : e.chatId]) === null || _tags$e$chatId === void 0 ? void 0 : _tags$e$chatId.map(function (e) {
      return /*#__PURE__*/React__default.createElement(Tag, {
        color: e === null || e === void 0 ? void 0 : e.color
      }, e === null || e === void 0 ? void 0 : e.name);
    }))));
  }));
};

var IconContext = /*#__PURE__*/createContext({});

function _extends$1() {
  _extends$1 = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends$1.apply(this, arguments);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"];
  if (null != _i) {
    var _s,
      _e,
      _x,
      _r,
      _arr = [],
      _n = !0,
      _d = !1;
    try {
      if (_x = (_i = _i.call(arr)).next, 0 === i) {
        if (Object(_i) !== _i) return;
        _n = !1;
      } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0);
    } catch (err) {
      _d = !0, _e = err;
    } finally {
      try {
        if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return;
      } finally {
        if (_d) throw _e;
      }
    }
    return _arr;
  }
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _typeof(obj) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  }, _typeof(obj);
}

function _toPrimitive(input, hint) {
  if (_typeof(input) !== "object" || input === null) return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== undefined) {
    var res = prim.call(input, hint || "default");
    if (_typeof(res) !== "object") return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}

function _toPropertyKey(arg) {
  var key = _toPrimitive(arg, "string");
  return _typeof(key) === "symbol" ? key : String(key);
}

function _defineProperty(obj, key, value) {
  key = _toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var classnames = createCommonjsModule(function (module) {
/*!
	Copyright (c) 2018 Jed Watson.
	Licensed under the MIT License (MIT), see
	http://jedwatson.github.io/classnames
*/
/* global define */

(function () {

	var hasOwn = {}.hasOwnProperty;

	function classNames() {
		var classes = [];

		for (var i = 0; i < arguments.length; i++) {
			var arg = arguments[i];
			if (!arg) continue;

			var argType = typeof arg;

			if (argType === 'string' || argType === 'number') {
				classes.push(arg);
			} else if (Array.isArray(arg)) {
				if (arg.length) {
					var inner = classNames.apply(null, arg);
					if (inner) {
						classes.push(inner);
					}
				}
			} else if (argType === 'object') {
				if (arg.toString !== Object.prototype.toString && !arg.toString.toString().includes('[native code]')) {
					classes.push(arg.toString());
					continue;
				}

				for (var key in arg) {
					if (hasOwn.call(arg, key) && arg[key]) {
						classes.push(key);
					}
				}
			}
		}

		return classes.join(' ');
	}

	if ( module.exports) {
		classNames.default = classNames;
		module.exports = classNames;
	} else {
		window.classNames = classNames;
	}
}());
});

/**
 * Take input from [0, n] and return it as [0, 1]
 * @hidden
 */
function bound01(n, max) {
    if (isOnePointZero(n)) {
        n = '100%';
    }
    var isPercent = isPercentage(n);
    n = max === 360 ? n : Math.min(max, Math.max(0, parseFloat(n)));
    // Automatically convert percentage into number
    if (isPercent) {
        n = parseInt(String(n * max), 10) / 100;
    }
    // Handle floating point rounding errors
    if (Math.abs(n - max) < 0.000001) {
        return 1;
    }
    // Convert into [0, 1] range if it isn't already
    if (max === 360) {
        // If n is a hue given in degrees,
        // wrap around out-of-range values into [0, 360] range
        // then convert into [0, 1].
        n = (n < 0 ? (n % max) + max : n % max) / parseFloat(String(max));
    }
    else {
        // If n not a hue given in degrees
        // Convert into [0, 1] range if it isn't already.
        n = (n % max) / parseFloat(String(max));
    }
    return n;
}
/**
 * Need to handle 1.0 as 100%, since once it is a number, there is no difference between it and 1
 * <http://stackoverflow.com/questions/7422072/javascript-how-to-detect-number-as-a-decimal-including-1-0>
 * @hidden
 */
function isOnePointZero(n) {
    return typeof n === 'string' && n.indexOf('.') !== -1 && parseFloat(n) === 1;
}
/**
 * Check to see if string passed in is a percentage
 * @hidden
 */
function isPercentage(n) {
    return typeof n === 'string' && n.indexOf('%') !== -1;
}
/**
 * Return a valid alpha value [0,1] with all invalid values being set to 1
 * @hidden
 */
function boundAlpha(a) {
    a = parseFloat(a);
    if (isNaN(a) || a < 0 || a > 1) {
        a = 1;
    }
    return a;
}
/**
 * Replace a decimal with it's percentage value
 * @hidden
 */
function convertToPercentage(n) {
    if (n <= 1) {
        return "".concat(Number(n) * 100, "%");
    }
    return n;
}
/**
 * Force a hex value to have 2 characters
 * @hidden
 */
function pad2(c) {
    return c.length === 1 ? '0' + c : String(c);
}

// `rgbToHsl`, `rgbToHsv`, `hslToRgb`, `hsvToRgb` modified from:
// <http://mjijackson.com/2008/02/rgb-to-hsl-and-rgb-to-hsv-color-model-conversion-algorithms-in-javascript>
/**
 * Handle bounds / percentage checking to conform to CSS color spec
 * <http://www.w3.org/TR/css3-color/>
 * *Assumes:* r, g, b in [0, 255] or [0, 1]
 * *Returns:* { r, g, b } in [0, 255]
 */
function rgbToRgb(r, g, b) {
    return {
        r: bound01(r, 255) * 255,
        g: bound01(g, 255) * 255,
        b: bound01(b, 255) * 255,
    };
}
function hue2rgb(p, q, t) {
    if (t < 0) {
        t += 1;
    }
    if (t > 1) {
        t -= 1;
    }
    if (t < 1 / 6) {
        return p + (q - p) * (6 * t);
    }
    if (t < 1 / 2) {
        return q;
    }
    if (t < 2 / 3) {
        return p + (q - p) * (2 / 3 - t) * 6;
    }
    return p;
}
/**
 * Converts an HSL color value to RGB.
 *
 * *Assumes:* h is contained in [0, 1] or [0, 360] and s and l are contained [0, 1] or [0, 100]
 * *Returns:* { r, g, b } in the set [0, 255]
 */
function hslToRgb(h, s, l) {
    var r;
    var g;
    var b;
    h = bound01(h, 360);
    s = bound01(s, 100);
    l = bound01(l, 100);
    if (s === 0) {
        // achromatic
        g = l;
        b = l;
        r = l;
    }
    else {
        var q = l < 0.5 ? l * (1 + s) : l + s - l * s;
        var p = 2 * l - q;
        r = hue2rgb(p, q, h + 1 / 3);
        g = hue2rgb(p, q, h);
        b = hue2rgb(p, q, h - 1 / 3);
    }
    return { r: r * 255, g: g * 255, b: b * 255 };
}
/**
 * Converts an RGB color value to HSV
 *
 * *Assumes:* r, g, and b are contained in the set [0, 255] or [0, 1]
 * *Returns:* { h, s, v } in [0,1]
 */
function rgbToHsv(r, g, b) {
    r = bound01(r, 255);
    g = bound01(g, 255);
    b = bound01(b, 255);
    var max = Math.max(r, g, b);
    var min = Math.min(r, g, b);
    var h = 0;
    var v = max;
    var d = max - min;
    var s = max === 0 ? 0 : d / max;
    if (max === min) {
        h = 0; // achromatic
    }
    else {
        switch (max) {
            case r:
                h = (g - b) / d + (g < b ? 6 : 0);
                break;
            case g:
                h = (b - r) / d + 2;
                break;
            case b:
                h = (r - g) / d + 4;
                break;
        }
        h /= 6;
    }
    return { h: h, s: s, v: v };
}
/**
 * Converts an HSV color value to RGB.
 *
 * *Assumes:* h is contained in [0, 1] or [0, 360] and s and v are contained in [0, 1] or [0, 100]
 * *Returns:* { r, g, b } in the set [0, 255]
 */
function hsvToRgb(h, s, v) {
    h = bound01(h, 360) * 6;
    s = bound01(s, 100);
    v = bound01(v, 100);
    var i = Math.floor(h);
    var f = h - i;
    var p = v * (1 - s);
    var q = v * (1 - f * s);
    var t = v * (1 - (1 - f) * s);
    var mod = i % 6;
    var r = [v, q, p, p, t, v][mod];
    var g = [t, v, v, q, p, p][mod];
    var b = [p, p, t, v, v, q][mod];
    return { r: r * 255, g: g * 255, b: b * 255 };
}
/**
 * Converts an RGB color to hex
 *
 * Assumes r, g, and b are contained in the set [0, 255]
 * Returns a 3 or 6 character hex
 */
function rgbToHex(r, g, b, allow3Char) {
    var hex = [
        pad2(Math.round(r).toString(16)),
        pad2(Math.round(g).toString(16)),
        pad2(Math.round(b).toString(16)),
    ];
    // Return a 3 character hex if possible
    if (allow3Char &&
        hex[0].startsWith(hex[0].charAt(1)) &&
        hex[1].startsWith(hex[1].charAt(1)) &&
        hex[2].startsWith(hex[2].charAt(1))) {
        return hex[0].charAt(0) + hex[1].charAt(0) + hex[2].charAt(0);
    }
    return hex.join('');
}
/** Converts a hex value to a decimal */
function convertHexToDecimal(h) {
    return parseIntFromHex(h) / 255;
}
/** Parse a base-16 hex value into a base-10 integer */
function parseIntFromHex(val) {
    return parseInt(val, 16);
}

// https://github.com/bahamas10/css-color-names/blob/master/css-color-names.json
/**
 * @hidden
 */
var names = {
    aliceblue: '#f0f8ff',
    antiquewhite: '#faebd7',
    aqua: '#00ffff',
    aquamarine: '#7fffd4',
    azure: '#f0ffff',
    beige: '#f5f5dc',
    bisque: '#ffe4c4',
    black: '#000000',
    blanchedalmond: '#ffebcd',
    blue: '#0000ff',
    blueviolet: '#8a2be2',
    brown: '#a52a2a',
    burlywood: '#deb887',
    cadetblue: '#5f9ea0',
    chartreuse: '#7fff00',
    chocolate: '#d2691e',
    coral: '#ff7f50',
    cornflowerblue: '#6495ed',
    cornsilk: '#fff8dc',
    crimson: '#dc143c',
    cyan: '#00ffff',
    darkblue: '#00008b',
    darkcyan: '#008b8b',
    darkgoldenrod: '#b8860b',
    darkgray: '#a9a9a9',
    darkgreen: '#006400',
    darkgrey: '#a9a9a9',
    darkkhaki: '#bdb76b',
    darkmagenta: '#8b008b',
    darkolivegreen: '#556b2f',
    darkorange: '#ff8c00',
    darkorchid: '#9932cc',
    darkred: '#8b0000',
    darksalmon: '#e9967a',
    darkseagreen: '#8fbc8f',
    darkslateblue: '#483d8b',
    darkslategray: '#2f4f4f',
    darkslategrey: '#2f4f4f',
    darkturquoise: '#00ced1',
    darkviolet: '#9400d3',
    deeppink: '#ff1493',
    deepskyblue: '#00bfff',
    dimgray: '#696969',
    dimgrey: '#696969',
    dodgerblue: '#1e90ff',
    firebrick: '#b22222',
    floralwhite: '#fffaf0',
    forestgreen: '#228b22',
    fuchsia: '#ff00ff',
    gainsboro: '#dcdcdc',
    ghostwhite: '#f8f8ff',
    goldenrod: '#daa520',
    gold: '#ffd700',
    gray: '#808080',
    green: '#008000',
    greenyellow: '#adff2f',
    grey: '#808080',
    honeydew: '#f0fff0',
    hotpink: '#ff69b4',
    indianred: '#cd5c5c',
    indigo: '#4b0082',
    ivory: '#fffff0',
    khaki: '#f0e68c',
    lavenderblush: '#fff0f5',
    lavender: '#e6e6fa',
    lawngreen: '#7cfc00',
    lemonchiffon: '#fffacd',
    lightblue: '#add8e6',
    lightcoral: '#f08080',
    lightcyan: '#e0ffff',
    lightgoldenrodyellow: '#fafad2',
    lightgray: '#d3d3d3',
    lightgreen: '#90ee90',
    lightgrey: '#d3d3d3',
    lightpink: '#ffb6c1',
    lightsalmon: '#ffa07a',
    lightseagreen: '#20b2aa',
    lightskyblue: '#87cefa',
    lightslategray: '#778899',
    lightslategrey: '#778899',
    lightsteelblue: '#b0c4de',
    lightyellow: '#ffffe0',
    lime: '#00ff00',
    limegreen: '#32cd32',
    linen: '#faf0e6',
    magenta: '#ff00ff',
    maroon: '#800000',
    mediumaquamarine: '#66cdaa',
    mediumblue: '#0000cd',
    mediumorchid: '#ba55d3',
    mediumpurple: '#9370db',
    mediumseagreen: '#3cb371',
    mediumslateblue: '#7b68ee',
    mediumspringgreen: '#00fa9a',
    mediumturquoise: '#48d1cc',
    mediumvioletred: '#c71585',
    midnightblue: '#191970',
    mintcream: '#f5fffa',
    mistyrose: '#ffe4e1',
    moccasin: '#ffe4b5',
    navajowhite: '#ffdead',
    navy: '#000080',
    oldlace: '#fdf5e6',
    olive: '#808000',
    olivedrab: '#6b8e23',
    orange: '#ffa500',
    orangered: '#ff4500',
    orchid: '#da70d6',
    palegoldenrod: '#eee8aa',
    palegreen: '#98fb98',
    paleturquoise: '#afeeee',
    palevioletred: '#db7093',
    papayawhip: '#ffefd5',
    peachpuff: '#ffdab9',
    peru: '#cd853f',
    pink: '#ffc0cb',
    plum: '#dda0dd',
    powderblue: '#b0e0e6',
    purple: '#800080',
    rebeccapurple: '#663399',
    red: '#ff0000',
    rosybrown: '#bc8f8f',
    royalblue: '#4169e1',
    saddlebrown: '#8b4513',
    salmon: '#fa8072',
    sandybrown: '#f4a460',
    seagreen: '#2e8b57',
    seashell: '#fff5ee',
    sienna: '#a0522d',
    silver: '#c0c0c0',
    skyblue: '#87ceeb',
    slateblue: '#6a5acd',
    slategray: '#708090',
    slategrey: '#708090',
    snow: '#fffafa',
    springgreen: '#00ff7f',
    steelblue: '#4682b4',
    tan: '#d2b48c',
    teal: '#008080',
    thistle: '#d8bfd8',
    tomato: '#ff6347',
    turquoise: '#40e0d0',
    violet: '#ee82ee',
    wheat: '#f5deb3',
    white: '#ffffff',
    whitesmoke: '#f5f5f5',
    yellow: '#ffff00',
    yellowgreen: '#9acd32',
};

/* eslint-disable @typescript-eslint/no-redundant-type-constituents */
/**
 * Given a string or object, convert that input to RGB
 *
 * Possible string inputs:
 * ```
 * "red"
 * "#f00" or "f00"
 * "#ff0000" or "ff0000"
 * "#ff000000" or "ff000000"
 * "rgb 255 0 0" or "rgb (255, 0, 0)"
 * "rgb 1.0 0 0" or "rgb (1, 0, 0)"
 * "rgba (255, 0, 0, 1)" or "rgba 255, 0, 0, 1"
 * "rgba (1.0, 0, 0, 1)" or "rgba 1.0, 0, 0, 1"
 * "hsl(0, 100%, 50%)" or "hsl 0 100% 50%"
 * "hsla(0, 100%, 50%, 1)" or "hsla 0 100% 50%, 1"
 * "hsv(0, 100%, 100%)" or "hsv 0 100% 100%"
 * ```
 */
function inputToRGB(color) {
    var rgb = { r: 0, g: 0, b: 0 };
    var a = 1;
    var s = null;
    var v = null;
    var l = null;
    var ok = false;
    var format = false;
    if (typeof color === 'string') {
        color = stringInputToObject(color);
    }
    if (typeof color === 'object') {
        if (isValidCSSUnit(color.r) && isValidCSSUnit(color.g) && isValidCSSUnit(color.b)) {
            rgb = rgbToRgb(color.r, color.g, color.b);
            ok = true;
            format = String(color.r).substr(-1) === '%' ? 'prgb' : 'rgb';
        }
        else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.v)) {
            s = convertToPercentage(color.s);
            v = convertToPercentage(color.v);
            rgb = hsvToRgb(color.h, s, v);
            ok = true;
            format = 'hsv';
        }
        else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.l)) {
            s = convertToPercentage(color.s);
            l = convertToPercentage(color.l);
            rgb = hslToRgb(color.h, s, l);
            ok = true;
            format = 'hsl';
        }
        if (Object.prototype.hasOwnProperty.call(color, 'a')) {
            a = color.a;
        }
    }
    a = boundAlpha(a);
    return {
        ok: ok,
        format: color.format || format,
        r: Math.min(255, Math.max(rgb.r, 0)),
        g: Math.min(255, Math.max(rgb.g, 0)),
        b: Math.min(255, Math.max(rgb.b, 0)),
        a: a,
    };
}
// <http://www.w3.org/TR/css3-values/#integers>
var CSS_INTEGER = '[-\\+]?\\d+%?';
// <http://www.w3.org/TR/css3-values/#number-value>
var CSS_NUMBER = '[-\\+]?\\d*\\.\\d+%?';
// Allow positive/negative integer/number.  Don't capture the either/or, just the entire outcome.
var CSS_UNIT = "(?:".concat(CSS_NUMBER, ")|(?:").concat(CSS_INTEGER, ")");
// Actual matching.
// Parentheses and commas are optional, but not required.
// Whitespace can take the place of commas or opening paren
var PERMISSIVE_MATCH3 = "[\\s|\\(]+(".concat(CSS_UNIT, ")[,|\\s]+(").concat(CSS_UNIT, ")[,|\\s]+(").concat(CSS_UNIT, ")\\s*\\)?");
var PERMISSIVE_MATCH4 = "[\\s|\\(]+(".concat(CSS_UNIT, ")[,|\\s]+(").concat(CSS_UNIT, ")[,|\\s]+(").concat(CSS_UNIT, ")[,|\\s]+(").concat(CSS_UNIT, ")\\s*\\)?");
var matchers = {
    CSS_UNIT: new RegExp(CSS_UNIT),
    rgb: new RegExp('rgb' + PERMISSIVE_MATCH3),
    rgba: new RegExp('rgba' + PERMISSIVE_MATCH4),
    hsl: new RegExp('hsl' + PERMISSIVE_MATCH3),
    hsla: new RegExp('hsla' + PERMISSIVE_MATCH4),
    hsv: new RegExp('hsv' + PERMISSIVE_MATCH3),
    hsva: new RegExp('hsva' + PERMISSIVE_MATCH4),
    hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
    hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
    hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
    hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
};
/**
 * Permissive string parsing.  Take in a number of formats, and output an object
 * based on detected format.  Returns `{ r, g, b }` or `{ h, s, l }` or `{ h, s, v}`
 */
function stringInputToObject(color) {
    color = color.trim().toLowerCase();
    if (color.length === 0) {
        return false;
    }
    var named = false;
    if (names[color]) {
        color = names[color];
        named = true;
    }
    else if (color === 'transparent') {
        return { r: 0, g: 0, b: 0, a: 0, format: 'name' };
    }
    // Try to match string input using regular expressions.
    // Keep most of the number bounding out of this function - don't worry about [0,1] or [0,100] or [0,360]
    // Just return an object and let the conversion functions handle that.
    // This way the result will be the same whether the tinycolor is initialized with string or object.
    var match = matchers.rgb.exec(color);
    if (match) {
        return { r: match[1], g: match[2], b: match[3] };
    }
    match = matchers.rgba.exec(color);
    if (match) {
        return { r: match[1], g: match[2], b: match[3], a: match[4] };
    }
    match = matchers.hsl.exec(color);
    if (match) {
        return { h: match[1], s: match[2], l: match[3] };
    }
    match = matchers.hsla.exec(color);
    if (match) {
        return { h: match[1], s: match[2], l: match[3], a: match[4] };
    }
    match = matchers.hsv.exec(color);
    if (match) {
        return { h: match[1], s: match[2], v: match[3] };
    }
    match = matchers.hsva.exec(color);
    if (match) {
        return { h: match[1], s: match[2], v: match[3], a: match[4] };
    }
    match = matchers.hex8.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1]),
            g: parseIntFromHex(match[2]),
            b: parseIntFromHex(match[3]),
            a: convertHexToDecimal(match[4]),
            format: named ? 'name' : 'hex8',
        };
    }
    match = matchers.hex6.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1]),
            g: parseIntFromHex(match[2]),
            b: parseIntFromHex(match[3]),
            format: named ? 'name' : 'hex',
        };
    }
    match = matchers.hex4.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1] + match[1]),
            g: parseIntFromHex(match[2] + match[2]),
            b: parseIntFromHex(match[3] + match[3]),
            a: convertHexToDecimal(match[4] + match[4]),
            format: named ? 'name' : 'hex8',
        };
    }
    match = matchers.hex3.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1] + match[1]),
            g: parseIntFromHex(match[2] + match[2]),
            b: parseIntFromHex(match[3] + match[3]),
            format: named ? 'name' : 'hex',
        };
    }
    return false;
}
/**
 * Check to see if it looks like a CSS unit
 * (see `matchers` above for definition).
 */
function isValidCSSUnit(color) {
    return Boolean(matchers.CSS_UNIT.exec(String(color)));
}

var hueStep = 2; // 色相阶梯

var saturationStep = 0.16; // 饱和度阶梯，浅色部分

var saturationStep2 = 0.05; // 饱和度阶梯，深色部分

var brightnessStep1 = 0.05; // 亮度阶梯，浅色部分

var brightnessStep2 = 0.15; // 亮度阶梯，深色部分

var lightColorCount = 5; // 浅色数量，主色上

var darkColorCount = 4; // 深色数量，主色下
// 暗色主题颜色映射关系表

var darkColorMap = [{
  index: 7,
  opacity: 0.15
}, {
  index: 6,
  opacity: 0.25
}, {
  index: 5,
  opacity: 0.3
}, {
  index: 5,
  opacity: 0.45
}, {
  index: 5,
  opacity: 0.65
}, {
  index: 5,
  opacity: 0.85
}, {
  index: 4,
  opacity: 0.9
}, {
  index: 3,
  opacity: 0.95
}, {
  index: 2,
  opacity: 0.97
}, {
  index: 1,
  opacity: 0.98
}];

// Wrapper function ported from TinyColor.prototype.toHsv
// Keep it here because of `hsv.h * 360`
function toHsv(_ref) {
  var r = _ref.r,
      g = _ref.g,
      b = _ref.b;
  var hsv = rgbToHsv(r, g, b);
  return {
    h: hsv.h * 360,
    s: hsv.s,
    v: hsv.v
  };
} // Wrapper function ported from TinyColor.prototype.toHexString
// Keep it here because of the prefix `#`


function toHex(_ref2) {
  var r = _ref2.r,
      g = _ref2.g,
      b = _ref2.b;
  return "#".concat(rgbToHex(r, g, b, false));
} // Wrapper function ported from TinyColor.prototype.mix, not treeshakable.
// Amount in range [0, 1]
// Assume color1 & color2 has no alpha, since the following src code did so.


function mix(rgb1, rgb2, amount) {
  var p = amount / 100;
  var rgb = {
    r: (rgb2.r - rgb1.r) * p + rgb1.r,
    g: (rgb2.g - rgb1.g) * p + rgb1.g,
    b: (rgb2.b - rgb1.b) * p + rgb1.b
  };
  return rgb;
}

function getHue(hsv, i, light) {
  var hue; // 根据色相不同，色相转向不同

  if (Math.round(hsv.h) >= 60 && Math.round(hsv.h) <= 240) {
    hue = light ? Math.round(hsv.h) - hueStep * i : Math.round(hsv.h) + hueStep * i;
  } else {
    hue = light ? Math.round(hsv.h) + hueStep * i : Math.round(hsv.h) - hueStep * i;
  }

  if (hue < 0) {
    hue += 360;
  } else if (hue >= 360) {
    hue -= 360;
  }

  return hue;
}

function getSaturation(hsv, i, light) {
  // grey color don't change saturation
  if (hsv.h === 0 && hsv.s === 0) {
    return hsv.s;
  }

  var saturation;

  if (light) {
    saturation = hsv.s - saturationStep * i;
  } else if (i === darkColorCount) {
    saturation = hsv.s + saturationStep;
  } else {
    saturation = hsv.s + saturationStep2 * i;
  } // 边界值修正


  if (saturation > 1) {
    saturation = 1;
  } // 第一格的 s 限制在 0.06-0.1 之间


  if (light && i === lightColorCount && saturation > 0.1) {
    saturation = 0.1;
  }

  if (saturation < 0.06) {
    saturation = 0.06;
  }

  return Number(saturation.toFixed(2));
}

function getValue(hsv, i, light) {
  var value;

  if (light) {
    value = hsv.v + brightnessStep1 * i;
  } else {
    value = hsv.v - brightnessStep2 * i;
  }

  if (value > 1) {
    value = 1;
  }

  return Number(value.toFixed(2));
}

function generate(color) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var patterns = [];
  var pColor = inputToRGB(color);

  for (var i = lightColorCount; i > 0; i -= 1) {
    var hsv = toHsv(pColor);
    var colorString = toHex(inputToRGB({
      h: getHue(hsv, i, true),
      s: getSaturation(hsv, i, true),
      v: getValue(hsv, i, true)
    }));
    patterns.push(colorString);
  }

  patterns.push(toHex(pColor));

  for (var _i = 1; _i <= darkColorCount; _i += 1) {
    var _hsv = toHsv(pColor);

    var _colorString = toHex(inputToRGB({
      h: getHue(_hsv, _i),
      s: getSaturation(_hsv, _i),
      v: getValue(_hsv, _i)
    }));

    patterns.push(_colorString);
  } // dark theme patterns


  if (opts.theme === 'dark') {
    return darkColorMap.map(function (_ref3) {
      var index = _ref3.index,
          opacity = _ref3.opacity;
      var darkColorString = toHex(mix(inputToRGB(opts.backgroundColor || '#141414'), inputToRGB(patterns[index]), opacity * 100));
      return darkColorString;
    });
  }

  return patterns;
}

var presetPrimaryColors = {
  red: '#F5222D',
  volcano: '#FA541C',
  orange: '#FA8C16',
  gold: '#FAAD14',
  yellow: '#FADB14',
  lime: '#A0D911',
  green: '#52C41A',
  cyan: '#13C2C2',
  blue: '#1677FF',
  geekblue: '#2F54EB',
  purple: '#722ED1',
  magenta: '#EB2F96',
  grey: '#666666'
};
var presetPalettes = {};
var presetDarkPalettes = {};
Object.keys(presetPrimaryColors).forEach(function (key) {
  presetPalettes[key] = generate(presetPrimaryColors[key]);
  presetPalettes[key].primary = presetPalettes[key][5]; // dark presetPalettes

  presetDarkPalettes[key] = generate(presetPrimaryColors[key], {
    theme: 'dark',
    backgroundColor: '#141414'
  });
  presetDarkPalettes[key].primary = presetDarkPalettes[key][5];
});
var blue = presetPalettes.blue;

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }
  return keys;
}
function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}

/* eslint-disable no-console */
var warned = {};
var preWarningFns = [];

/**
 * Pre warning enable you to parse content before console.error.
 * Modify to null will prevent warning.
 */
var preMessage = function preMessage(fn) {
  preWarningFns.push(fn);
};
function warning(valid, message) {
  // Support uglify
  if (process.env.NODE_ENV !== 'production' && !valid && console !== undefined) {
    var finalMessage = preWarningFns.reduce(function (msg, preMessageFn) {
      return preMessageFn(msg !== null && msg !== void 0 ? msg : '', 'warning');
    }, message);
    if (finalMessage) {
      console.error("Warning: ".concat(finalMessage));
    }
  }
}
function note(valid, message) {
  // Support uglify
  if (process.env.NODE_ENV !== 'production' && !valid && console !== undefined) {
    var finalMessage = preWarningFns.reduce(function (msg, preMessageFn) {
      return preMessageFn(msg !== null && msg !== void 0 ? msg : '', 'note');
    }, message);
    if (finalMessage) {
      console.warn("Note: ".concat(finalMessage));
    }
  }
}
function resetWarned() {
  warned = {};
}
function call(method, valid, message) {
  if (!valid && !warned[message]) {
    method(false, message);
    warned[message] = true;
  }
}
function warningOnce(valid, message) {
  call(warning, valid, message);
}
function noteOnce(valid, message) {
  call(note, valid, message);
}
warningOnce.preMessage = preMessage;
warningOnce.resetWarned = resetWarned;
warningOnce.noteOnce = noteOnce;
/* eslint-enable */

function canUseDom() {
  return !!(typeof window !== 'undefined' && window.document && window.document.createElement);
}

function contains(root, n) {
  if (!root) {
    return false;
  }

  // Use native if support
  if (root.contains) {
    return root.contains(n);
  }

  // `document.contains` not support with IE11
  var node = n;
  while (node) {
    if (node === root) {
      return true;
    }
    node = node.parentNode;
  }
  return false;
}

var APPEND_ORDER = 'data-rc-order';
var MARK_KEY = "rc-util-key";
var containerCache = new Map();
function getMark() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    mark = _ref.mark;
  if (mark) {
    return mark.startsWith('data-') ? mark : "data-".concat(mark);
  }
  return MARK_KEY;
}
function getContainer(option) {
  if (option.attachTo) {
    return option.attachTo;
  }
  var head = document.querySelector('head');
  return head || document.body;
}
function getOrder(prepend) {
  if (prepend === 'queue') {
    return 'prependQueue';
  }
  return prepend ? 'prepend' : 'append';
}

/**
 * Find style which inject by rc-util
 */
function findStyles(container) {
  return Array.from((containerCache.get(container) || container).children).filter(function (node) {
    return node.tagName === 'STYLE';
  });
}
function injectCSS(css) {
  var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  if (!canUseDom()) {
    return null;
  }
  var csp = option.csp,
    prepend = option.prepend;
  var styleNode = document.createElement('style');
  styleNode.setAttribute(APPEND_ORDER, getOrder(prepend));
  if (csp !== null && csp !== void 0 && csp.nonce) {
    styleNode.nonce = csp === null || csp === void 0 ? void 0 : csp.nonce;
  }
  styleNode.innerHTML = css;
  var container = getContainer(option);
  var firstChild = container.firstChild;
  if (prepend) {
    // If is queue `prepend`, it will prepend first style and then append rest style
    if (prepend === 'queue') {
      var existStyle = findStyles(container).filter(function (node) {
        return ['prepend', 'prependQueue'].includes(node.getAttribute(APPEND_ORDER));
      });
      if (existStyle.length) {
        container.insertBefore(styleNode, existStyle[existStyle.length - 1].nextSibling);
        return styleNode;
      }
    }

    // Use `insertBefore` as `prepend`
    container.insertBefore(styleNode, firstChild);
  } else {
    container.appendChild(styleNode);
  }
  return styleNode;
}
function findExistNode(key) {
  var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var container = getContainer(option);
  return findStyles(container).find(function (node) {
    return node.getAttribute(getMark(option)) === key;
  });
}

/**
 * qiankun will inject `appendChild` to insert into other
 */
function syncRealContainer(container, option) {
  var cachedRealContainer = containerCache.get(container);

  // Find real container when not cached or cached container removed
  if (!cachedRealContainer || !contains(document, cachedRealContainer)) {
    var placeholderStyle = injectCSS('', option);
    var parentNode = placeholderStyle.parentNode;
    containerCache.set(container, parentNode);
    container.removeChild(placeholderStyle);
  }
}
function updateCSS(css, key) {
  var option = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var container = getContainer(option);

  // Sync real parent
  syncRealContainer(container, option);
  var existNode = findExistNode(key, option);
  if (existNode) {
    var _option$csp, _option$csp2;
    if ((_option$csp = option.csp) !== null && _option$csp !== void 0 && _option$csp.nonce && existNode.nonce !== ((_option$csp2 = option.csp) === null || _option$csp2 === void 0 ? void 0 : _option$csp2.nonce)) {
      var _option$csp3;
      existNode.nonce = (_option$csp3 = option.csp) === null || _option$csp3 === void 0 ? void 0 : _option$csp3.nonce;
    }
    if (existNode.innerHTML !== css) {
      existNode.innerHTML = css;
    }
    return existNode;
  }
  var newNode = injectCSS(css, option);
  newNode.setAttribute(getMark(option), key);
  return newNode;
}

function getRoot(ele) {
  var _ele$getRootNode;
  return ele === null || ele === void 0 ? void 0 : (_ele$getRootNode = ele.getRootNode) === null || _ele$getRootNode === void 0 ? void 0 : _ele$getRootNode.call(ele);
}

/**
 * Check if is in shadowRoot
 */
function inShadow(ele) {
  return getRoot(ele) !== (ele === null || ele === void 0 ? void 0 : ele.ownerDocument);
}

/**
 * Return shadowRoot if possible
 */
function getShadowRoot(ele) {
  return inShadow(ele) ? getRoot(ele) : null;
}

function warning$1(valid, message) {
  warningOnce(valid, "[@ant-design/icons] ".concat(message));
}
function isIconDefinition(target) {
  return _typeof(target) === 'object' && typeof target.name === 'string' && typeof target.theme === 'string' && (_typeof(target.icon) === 'object' || typeof target.icon === 'function');
}
function normalizeAttrs() {
  var attrs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return Object.keys(attrs).reduce(function (acc, key) {
    var val = attrs[key];
    switch (key) {
      case 'class':
        acc.className = val;
        delete acc.class;
        break;
      default:
        acc[key] = val;
    }
    return acc;
  }, {});
}
function generate$1(node, key, rootProps) {
  if (!rootProps) {
    return /*#__PURE__*/React__default.createElement(node.tag, _objectSpread2({
      key: key
    }, normalizeAttrs(node.attrs)), (node.children || []).map(function (child, index) {
      return generate$1(child, "".concat(key, "-").concat(node.tag, "-").concat(index));
    }));
  }
  return /*#__PURE__*/React__default.createElement(node.tag, _objectSpread2(_objectSpread2({
    key: key
  }, normalizeAttrs(node.attrs)), rootProps), (node.children || []).map(function (child, index) {
    return generate$1(child, "".concat(key, "-").concat(node.tag, "-").concat(index));
  }));
}
function getSecondaryColor(primaryColor) {
  // choose the second color
  return generate(primaryColor)[0];
}
function normalizeTwoToneColors(twoToneColor) {
  if (!twoToneColor) {
    return [];
  }
  return Array.isArray(twoToneColor) ? twoToneColor : [twoToneColor];
}
var iconStyles = "\n.anticon {\n  display: inline-block;\n  color: inherit;\n  font-style: normal;\n  line-height: 0;\n  text-align: center;\n  text-transform: none;\n  vertical-align: -0.125em;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n}\n\n.anticon > * {\n  line-height: 1;\n}\n\n.anticon svg {\n  display: inline-block;\n}\n\n.anticon::before {\n  display: none;\n}\n\n.anticon .anticon-icon {\n  display: block;\n}\n\n.anticon[tabindex] {\n  cursor: pointer;\n}\n\n.anticon-spin::before,\n.anticon-spin {\n  display: inline-block;\n  -webkit-animation: loadingCircle 1s infinite linear;\n  animation: loadingCircle 1s infinite linear;\n}\n\n@-webkit-keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n\n@keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n";
var useInsertStyles = function useInsertStyles(eleRef) {
  var _useContext = useContext(IconContext),
    csp = _useContext.csp,
    prefixCls = _useContext.prefixCls;
  var mergedStyleStr = iconStyles;
  if (prefixCls) {
    mergedStyleStr = mergedStyleStr.replace(/anticon/g, prefixCls);
  }
  useEffect(function () {
    var ele = eleRef.current;
    var shadowRoot = getShadowRoot(ele);
    updateCSS(mergedStyleStr, '@ant-design-icons', {
      prepend: true,
      csp: csp,
      attachTo: shadowRoot
    });
  }, []);
};

var _excluded = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"];
var twoToneColorPalette = {
  primaryColor: '#333',
  secondaryColor: '#E6E6E6',
  calculated: false
};
function setTwoToneColors(_ref) {
  var primaryColor = _ref.primaryColor,
    secondaryColor = _ref.secondaryColor;
  twoToneColorPalette.primaryColor = primaryColor;
  twoToneColorPalette.secondaryColor = secondaryColor || getSecondaryColor(primaryColor);
  twoToneColorPalette.calculated = !!secondaryColor;
}
function getTwoToneColors() {
  return _objectSpread2({}, twoToneColorPalette);
}
var IconBase = function IconBase(props) {
  var icon = props.icon,
    className = props.className,
    onClick = props.onClick,
    style = props.style,
    primaryColor = props.primaryColor,
    secondaryColor = props.secondaryColor,
    restProps = _objectWithoutProperties(props, _excluded);
  var svgRef = useRef();
  var colors = twoToneColorPalette;
  if (primaryColor) {
    colors = {
      primaryColor: primaryColor,
      secondaryColor: secondaryColor || getSecondaryColor(primaryColor)
    };
  }
  useInsertStyles(svgRef);
  warning$1(isIconDefinition(icon), "icon should be icon definiton, but got ".concat(icon));
  if (!isIconDefinition(icon)) {
    return null;
  }
  var target = icon;
  if (target && typeof target.icon === 'function') {
    target = _objectSpread2(_objectSpread2({}, target), {}, {
      icon: target.icon(colors.primaryColor, colors.secondaryColor)
    });
  }
  return generate$1(target.icon, "svg-".concat(target.name), _objectSpread2(_objectSpread2({
    className: className,
    onClick: onClick,
    style: style,
    'data-icon': target.name,
    width: '1em',
    height: '1em',
    fill: 'currentColor',
    'aria-hidden': 'true'
  }, restProps), {}, {
    ref: svgRef
  }));
};
IconBase.displayName = 'IconReact';
IconBase.getTwoToneColors = getTwoToneColors;
IconBase.setTwoToneColors = setTwoToneColors;

function setTwoToneColor(twoToneColor) {
  var _normalizeTwoToneColo = normalizeTwoToneColors(twoToneColor),
    _normalizeTwoToneColo2 = _slicedToArray(_normalizeTwoToneColo, 2),
    primaryColor = _normalizeTwoToneColo2[0],
    secondaryColor = _normalizeTwoToneColo2[1];
  return IconBase.setTwoToneColors({
    primaryColor: primaryColor,
    secondaryColor: secondaryColor
  });
}
function getTwoToneColor() {
  var colors = IconBase.getTwoToneColors();
  if (!colors.calculated) {
    return colors.primaryColor;
  }
  return [colors.primaryColor, colors.secondaryColor];
}

var _excluded$1 = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
// Initial setting
// should move it to antd main repo?
setTwoToneColor(blue.primary);

// https://github.com/DefinitelyTyped/DefinitelyTyped/issues/34757#issuecomment-488848720

var Icon = /*#__PURE__*/forwardRef(function (props, ref) {
  var _classNames;
  var className = props.className,
    icon = props.icon,
    spin = props.spin,
    rotate = props.rotate,
    tabIndex = props.tabIndex,
    onClick = props.onClick,
    twoToneColor = props.twoToneColor,
    restProps = _objectWithoutProperties(props, _excluded$1);
  var _React$useContext = useContext(IconContext),
    _React$useContext$pre = _React$useContext.prefixCls,
    prefixCls = _React$useContext$pre === void 0 ? 'anticon' : _React$useContext$pre,
    rootClassName = _React$useContext.rootClassName;
  var classString = classnames(rootClassName, prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-").concat(icon.name), !!icon.name), _defineProperty(_classNames, "".concat(prefixCls, "-spin"), !!spin || icon.name === 'loading'), _classNames), className);
  var iconTabIndex = tabIndex;
  if (iconTabIndex === undefined && onClick) {
    iconTabIndex = -1;
  }
  var svgStyle = rotate ? {
    msTransform: "rotate(".concat(rotate, "deg)"),
    transform: "rotate(".concat(rotate, "deg)")
  } : undefined;
  var _normalizeTwoToneColo = normalizeTwoToneColors(twoToneColor),
    _normalizeTwoToneColo2 = _slicedToArray(_normalizeTwoToneColo, 2),
    primaryColor = _normalizeTwoToneColo2[0],
    secondaryColor = _normalizeTwoToneColo2[1];
  return /*#__PURE__*/createElement("span", _extends$1({
    role: "img",
    "aria-label": icon.name
  }, restProps, {
    ref: ref,
    tabIndex: iconTabIndex,
    onClick: onClick,
    className: classString
  }), /*#__PURE__*/createElement(IconBase, {
    icon: icon,
    primaryColor: primaryColor,
    secondaryColor: secondaryColor,
    style: svgStyle
  }));
});
Icon.displayName = 'AntdIcon';
Icon.getTwoToneColor = getTwoToneColor;
Icon.setTwoToneColor = setTwoToneColor;

// This icon file is generated automatically.
var CloseOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M563.8 512l262.5-312.9c4.4-5.2.7-13.1-6.1-13.1h-79.8c-4.7 0-9.2 2.1-12.3 5.7L511.6 449.8 295.1 191.7c-3-3.6-7.5-5.7-12.3-5.7H203c-6.8 0-10.5 7.9-6.1 13.1L459.4 512 196.9 824.9A7.95 7.95 0 00203 838h79.8c4.7 0 9.2-2.1 12.3-5.7l216.5-258.1 216.5 258.1c3 3.6 7.5 5.7 12.3 5.7h79.8c6.8 0 10.5-7.9 6.1-13.1L563.8 512z" } }] }, "name": "close", "theme": "outlined" };

var CloseOutlined$1 = function CloseOutlined$1(props, ref) {
  return /*#__PURE__*/createElement(Icon, _extends$1({}, props, {
    ref: ref,
    icon: CloseOutlined
  }));
};
if (process.env.NODE_ENV !== 'production') {
  CloseOutlined$1.displayName = 'CloseOutlined';
}
var CloseOutlined$2 = /*#__PURE__*/forwardRef(CloseOutlined$1);

// This icon file is generated automatically.
var FileImageOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M553.1 509.1l-77.8 99.2-41.1-52.4a8 8 0 00-12.6 0l-99.8 127.2a7.98 7.98 0 006.3 12.9H696c6.7 0 10.4-7.7 6.3-12.9l-136.5-174a8.1 8.1 0 00-12.7 0zM360 442a40 40 0 1080 0 40 40 0 10-80 0zm494.6-153.4L639.4 73.4c-6-6-14.1-9.4-22.6-9.4H192c-17.7 0-32 14.3-32 32v832c0 17.7 14.3 32 32 32h640c17.7 0 32-14.3 32-32V311.3c0-8.5-3.4-16.7-9.4-22.7zM790.2 326H602V137.8L790.2 326zm1.8 562H232V136h302v216a42 42 0 0042 42h216v494z" } }] }, "name": "file-image", "theme": "outlined" };

var FileImageOutlined$1 = function FileImageOutlined$1(props, ref) {
  return /*#__PURE__*/createElement(Icon, _extends$1({}, props, {
    ref: ref,
    icon: FileImageOutlined
  }));
};
if (process.env.NODE_ENV !== 'production') {
  FileImageOutlined$1.displayName = 'FileImageOutlined';
}
var FileImageOutlined$2 = /*#__PURE__*/forwardRef(FileImageOutlined$1);

// This icon file is generated automatically.
var FileTextOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M854.6 288.6L639.4 73.4c-6-6-14.1-9.4-22.6-9.4H192c-17.7 0-32 14.3-32 32v832c0 17.7 14.3 32 32 32h640c17.7 0 32-14.3 32-32V311.3c0-8.5-3.4-16.7-9.4-22.7zM790.2 326H602V137.8L790.2 326zm1.8 562H232V136h302v216a42 42 0 0042 42h216v494zM504 618H320c-4.4 0-8 3.6-8 8v48c0 4.4 3.6 8 8 8h184c4.4 0 8-3.6 8-8v-48c0-4.4-3.6-8-8-8zM312 490v48c0 4.4 3.6 8 8 8h384c4.4 0 8-3.6 8-8v-48c0-4.4-3.6-8-8-8H320c-4.4 0-8 3.6-8 8z" } }] }, "name": "file-text", "theme": "outlined" };

var FileTextOutlined$1 = function FileTextOutlined$1(props, ref) {
  return /*#__PURE__*/createElement(Icon, _extends$1({}, props, {
    ref: ref,
    icon: FileTextOutlined
  }));
};
if (process.env.NODE_ENV !== 'production') {
  FileTextOutlined$1.displayName = 'FileTextOutlined';
}
var FileTextOutlined$2 = /*#__PURE__*/forwardRef(FileTextOutlined$1);

// This icon file is generated automatically.
var PaperClipOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M779.3 196.6c-94.2-94.2-247.6-94.2-341.7 0l-261 260.8c-1.7 1.7-2.6 4-2.6 6.4s.9 4.7 2.6 6.4l36.9 36.9a9 9 0 0012.7 0l261-260.8c32.4-32.4 75.5-50.2 121.3-50.2s88.9 17.8 121.2 50.2c32.4 32.4 50.2 75.5 50.2 121.2 0 45.8-17.8 88.8-50.2 121.2l-266 265.9-43.1 43.1c-40.3 40.3-105.8 40.3-146.1 0-19.5-19.5-30.2-45.4-30.2-73s10.7-53.5 30.2-73l263.9-263.8c6.7-6.6 15.5-10.3 24.9-10.3h.1c9.4 0 18.1 3.7 24.7 10.3 6.7 6.7 10.3 15.5 10.3 24.9 0 9.3-3.7 18.1-10.3 24.7L372.4 653c-1.7 1.7-2.6 4-2.6 6.4s.9 4.7 2.6 6.4l36.9 36.9a9 9 0 0012.7 0l215.6-215.6c19.9-19.9 30.8-46.3 30.8-74.4s-11-54.6-30.8-74.4c-41.1-41.1-107.9-41-149 0L463 364 224.8 602.1A172.22 172.22 0 00174 724.8c0 46.3 18.1 89.8 50.8 122.5 33.9 33.8 78.3 50.7 122.7 50.7 44.4 0 88.8-16.9 122.6-50.7l309.2-309C824.8 492.7 850 432 850 367.5c.1-64.6-25.1-125.3-70.7-170.9z" } }] }, "name": "paper-clip", "theme": "outlined" };

var PaperClipOutlined$1 = function PaperClipOutlined$1(props, ref) {
  return /*#__PURE__*/createElement(Icon, _extends$1({}, props, {
    ref: ref,
    icon: PaperClipOutlined
  }));
};
if (process.env.NODE_ENV !== 'production') {
  PaperClipOutlined$1.displayName = 'PaperClipOutlined';
}
var PaperClipOutlined$2 = /*#__PURE__*/forwardRef(PaperClipOutlined$1);

// This icon file is generated automatically.
var SendOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "defs", "attrs": {}, "children": [{ "tag": "style", "attrs": {} }] }, { "tag": "path", "attrs": { "d": "M931.4 498.9L94.9 79.5c-3.4-1.7-7.3-2.1-11-1.2a15.99 15.99 0 00-11.7 19.3l86.2 352.2c1.3 5.3 5.2 9.6 10.4 11.3l147.7 50.7-147.6 50.7c-5.2 1.8-9.1 6-10.3 11.3L72.2 926.5c-.9 3.7-.5 7.6 1.2 10.9 3.9 7.9 13.5 11.1 21.5 7.2l836.5-417c3.1-1.5 5.6-4.1 7.2-7.1 3.9-8 .7-17.6-7.2-21.6zM170.8 826.3l50.3-205.6 295.2-101.3c2.3-.8 4.2-2.6 5-5 1.4-4.2-.8-8.7-5-10.2L221.1 403 171 198.2l628 314.9-628.2 313.2z" } }] }, "name": "send", "theme": "outlined" };

var SendOutlined$1 = function SendOutlined$1(props, ref) {
  return /*#__PURE__*/createElement(Icon, _extends$1({}, props, {
    ref: ref,
    icon: SendOutlined
  }));
};
if (process.env.NODE_ENV !== 'production') {
  SendOutlined$1.displayName = 'SendOutlined';
}
var SendOutlined$2 = /*#__PURE__*/forwardRef(SendOutlined$1);

// This icon file is generated automatically.
var WarningOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M464 720a48 48 0 1096 0 48 48 0 10-96 0zm16-304v184c0 4.4 3.6 8 8 8h48c4.4 0 8-3.6 8-8V416c0-4.4-3.6-8-8-8h-48c-4.4 0-8 3.6-8 8zm475.7 440l-416-720c-6.2-10.7-16.9-16-27.7-16s-21.6 5.3-27.7 16l-416 720C56 877.4 71.4 904 96 904h832c24.6 0 40-26.6 27.7-48zm-783.5-27.9L512 239.9l339.8 588.2H172.2z" } }] }, "name": "warning", "theme": "outlined" };

var WarningOutlined$1 = function WarningOutlined$1(props, ref) {
  return /*#__PURE__*/createElement(Icon, _extends$1({}, props, {
    ref: ref,
    icon: WarningOutlined
  }));
};
if (process.env.NODE_ENV !== 'production') {
  WarningOutlined$1.displayName = 'WarningOutlined';
}
var WarningOutlined$2 = /*#__PURE__*/forwardRef(WarningOutlined$1);

var MessagesRender = forwardRef(function (props, ref) {
  var _props$messages = props.messages,
    messages = _props$messages === void 0 ? [] : _props$messages,
    _props$startReached = props.startReached,
    startReached = _props$startReached === void 0 ? function () {} : _props$startReached,
    _props$type = props.type,
    type = _props$type === void 0 ? CONST.CONVERSATION_TYPE.MESSENGER : _props$type,
    _props$messageStyle = props.messageStyle,
    messageStyle = _props$messageStyle === void 0 ? {} : _props$messageStyle;
  var _useState = useState(0),
    scrollBottom = _useState[0],
    setScrollBottom = _useState[1];
  useImperativeHandle(ref, function () {
    return {
      scrollToBottom: function scrollToBottom() {
        return _scrollToBottom();
      }
    };
  });
  var messagesRef = useRef(null);
  var bottomRef = useRef(null);
  useEffect(function () {
    _scrollToBottom();
  }, []);
  useEffect(function () {
    var _messagesRef$current;
    var scrollHeight = messagesRef === null || messagesRef === void 0 ? void 0 : (_messagesRef$current = messagesRef.current) === null || _messagesRef$current === void 0 ? void 0 : _messagesRef$current.scrollHeight;
    var top = scrollHeight - scrollBottom;
    scrollToPosition(top);
  }, [messages]);
  var _scrollToBottom = function _scrollToBottom(behavior) {
    var _bottomRef$current;
    if (behavior === void 0) {
      behavior = 'auto';
    }
    (_bottomRef$current = bottomRef.current) === null || _bottomRef$current === void 0 ? void 0 : _bottomRef$current.scrollIntoView({
      behavior: behavior
    });
  };
  var scrollToPosition = function scrollToPosition(top, behavior) {
    var _messagesRef$current2;
    if (behavior === void 0) {
      behavior = 'auto';
    }
    (_messagesRef$current2 = messagesRef.current) === null || _messagesRef$current2 === void 0 ? void 0 : _messagesRef$current2.scrollTo({
      top: top,
      behavior: behavior
    });
  };
  var handleScroll = function handleScroll(event) {
    var scrollTop = event.currentTarget.scrollTop;
    var scrollHeight = event.currentTarget.scrollHeight;
    var scrollBottom = scrollHeight - scrollTop;
    if (scrollTop < scrollHeight / 4) {
      setScrollBottom(scrollBottom);
      startReached();
    }
  };
  var renderTime = function renderTime(rowData, index, time_field) {
    if (time_field === void 0) {
      time_field = 'time';
    }
    var preRow = messages === null || messages === void 0 ? void 0 : messages[index - 1];
    if (!preRow || moment(rowData === null || rowData === void 0 ? void 0 : rowData[time_field]).diff(moment(preRow === null || preRow === void 0 ? void 0 : preRow[time_field]), 'minutes') > 30) {
      return /*#__PURE__*/React__default.createElement("div", {
        style: {
          textAlign: 'center',
          marginTop: 12,
          color: '#999',
          fontWeight: 400,
          fontSize: 12
        }
      }, moment(rowData === null || rowData === void 0 ? void 0 : rowData[time_field]).format('HH:mm, DD [tháng] MM, YYYY'));
    }
    return null;
  };
  var renderZaloNosupport = function renderZaloNosupport(rowData, index) {
    var _rowData$response, _rowData$style, _rowData$response2, _rowData$response2$pa, _rowData$response2$pa2, _rowData$response3, _rowData$response3$pa, _rowData$style2, _rowData$style3, _rowData$style4, _rowData$style5;
    switch (rowData === null || rowData === void 0 ? void 0 : (_rowData$response = rowData.response) === null || _rowData$response === void 0 ? void 0 : _rowData$response.eventName) {
      case 'oa_send_template':
        return /*#__PURE__*/React__default.createElement("div", {
          key: index
        }, renderTime(rowData, index), /*#__PURE__*/React__default.createElement("div", {
          style: {
            display: 'flex',
            justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style = rowData.style) === null || _rowData$style === void 0 ? void 0 : _rowData$style.justifyContent
          },
          key: rowData === null || rowData === void 0 ? void 0 : rowData.id
        }, /*#__PURE__*/React__default.createElement("div", {
          style: _extends({
            padding: '4px 8px',
            borderRadius: 12,
            whiteSpace: 'pre-wrap',
            overflowWrap: 'break-word',
            maxWidth: 320
          }, rowData === null || rowData === void 0 ? void 0 : rowData.style)
        }, "" + (rowData === null || rowData === void 0 ? void 0 : (_rowData$response2 = rowData.response) === null || _rowData$response2 === void 0 ? void 0 : (_rowData$response2$pa = _rowData$response2.payloads) === null || _rowData$response2$pa === void 0 ? void 0 : (_rowData$response2$pa2 = _rowData$response2$pa[0]) === null || _rowData$response2$pa2 === void 0 ? void 0 : _rowData$response2$pa2.templateText))));
      case 'oa_send_file':
        var attachment = rowData === null || rowData === void 0 ? void 0 : (_rowData$response3 = rowData.response) === null || _rowData$response3 === void 0 ? void 0 : (_rowData$response3$pa = _rowData$response3.payloads) === null || _rowData$response3$pa === void 0 ? void 0 : _rowData$response3$pa[0];
        return /*#__PURE__*/React__default.createElement("div", {
          key: index
        }, renderTime(rowData, index), /*#__PURE__*/React__default.createElement("div", {
          style: {
            display: 'flex',
            justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style2 = rowData.style) === null || _rowData$style2 === void 0 ? void 0 : _rowData$style2.justifyContent
          },
          key: rowData === null || rowData === void 0 ? void 0 : rowData.id
        }, /*#__PURE__*/React__default.createElement("div", {
          style: _extends({
            padding: '4px 8px'
          }, rowData === null || rowData === void 0 ? void 0 : rowData.style, {
            margin: 0,
            backgroundColor: 'transparent'
          }, messageStyle)
        }, /*#__PURE__*/React__default.createElement("a", {
          href: attachment === null || attachment === void 0 ? void 0 : attachment.url
        }, /*#__PURE__*/React__default.createElement(Space, {
          style: {
            cursor: 'pointer',
            padding: '4px 8px',
            borderRadius: 12,
            color: rowData === null || rowData === void 0 ? void 0 : (_rowData$style3 = rowData.style) === null || _rowData$style3 === void 0 ? void 0 : _rowData$style3.color,
            backgroundColor: rowData === null || rowData === void 0 ? void 0 : (_rowData$style4 = rowData.style) === null || _rowData$style4 === void 0 ? void 0 : _rowData$style4.backgroundColor
          }
        }, /*#__PURE__*/React__default.createElement("div", {
          style: {
            display: 'flex',
            alignItems: 'center',
            justifyContent: 'center',
            width: 36,
            height: 36,
            borderRadius: 18,
            backgroundColor: '#fff'
          }
        }, /*#__PURE__*/React__default.createElement(FileTextOutlined$2, {
          style: {
            fontSize: 16,
            color: '#136DFB'
          }
        })), /*#__PURE__*/React__default.createElement("div", {
          style: {
            textDecoration: 'underline'
          }
        }, (attachment === null || attachment === void 0 ? void 0 : attachment.fileName) || (attachment === null || attachment === void 0 ? void 0 : attachment.name)))))));
      default:
        return /*#__PURE__*/React__default.createElement("div", {
          key: index
        }, renderTime(rowData, index), /*#__PURE__*/React__default.createElement("div", {
          style: {
            display: 'flex',
            justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style5 = rowData.style) === null || _rowData$style5 === void 0 ? void 0 : _rowData$style5.justifyContent
          },
          key: rowData === null || rowData === void 0 ? void 0 : rowData.id
        }, /*#__PURE__*/React__default.createElement(Space, {
          style: {
            margin: '6px 12px',
            color: '#888'
          }
        }, /*#__PURE__*/React__default.createElement(WarningOutlined$2, {
          style: {
            fontSize: 20
          }
        }), /*#__PURE__*/React__default.createElement("div", null, "N\u1ED9i dung kh\xF4ng h\u1ED7 tr\u1EE3"))));
    }
  };
  var renderMessageZaloByType = function renderMessageZaloByType(rowData, index) {
    var _rowData$style6, _rowData$style7, _rowData$style8, _rowData$style9, _rowData$style10;
    switch (rowData.type) {
      case 'text':
        return /*#__PURE__*/React__default.createElement("div", {
          key: index
        }, renderTime(rowData, index), /*#__PURE__*/React__default.createElement("div", {
          style: {
            display: 'flex',
            justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style6 = rowData.style) === null || _rowData$style6 === void 0 ? void 0 : _rowData$style6.justifyContent
          },
          key: rowData === null || rowData === void 0 ? void 0 : rowData.id
        }, /*#__PURE__*/React__default.createElement("div", {
          style: _extends({
            padding: '4px 8px',
            borderRadius: 12,
            whiteSpace: 'pre-wrap',
            overflowWrap: 'break-word',
            maxWidth: 320
          }, rowData === null || rowData === void 0 ? void 0 : rowData.style)
        }, "" + (rowData === null || rowData === void 0 ? void 0 : rowData.message))));
      case 'sticker':
        return /*#__PURE__*/React__default.createElement("div", {
          key: index
        }, renderTime(rowData, index), /*#__PURE__*/React__default.createElement("div", {
          style: {
            display: 'flex',
            justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style7 = rowData.style) === null || _rowData$style7 === void 0 ? void 0 : _rowData$style7.justifyContent
          },
          key: rowData === null || rowData === void 0 ? void 0 : rowData.id
        }, /*#__PURE__*/React__default.createElement("img", {
          src: rowData === null || rowData === void 0 ? void 0 : rowData.url,
          style: {
            maxWidth: 100,
            margin: '6px 12px'
          }
        })));
      case 'photo':
        return /*#__PURE__*/React__default.createElement("div", {
          key: index
        }, renderTime(rowData, index), /*#__PURE__*/React__default.createElement("div", {
          style: {
            display: 'flex',
            justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style8 = rowData.style) === null || _rowData$style8 === void 0 ? void 0 : _rowData$style8.justifyContent,
            margin: '6px 12px'
          },
          key: rowData === null || rowData === void 0 ? void 0 : rowData.id
        }, /*#__PURE__*/React__default.createElement("img", {
          src: rowData === null || rowData === void 0 ? void 0 : rowData.url,
          style: {
            maxWidth: messageStyle === null || messageStyle === void 0 ? void 0 : messageStyle.maxWidth,
            width: '100%'
          }
        })));
      case 'gif':
        return /*#__PURE__*/React__default.createElement("div", {
          key: index
        }, renderTime(rowData, index), /*#__PURE__*/React__default.createElement("div", {
          style: {
            display: 'flex',
            justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style9 = rowData.style) === null || _rowData$style9 === void 0 ? void 0 : _rowData$style9.justifyContent
          },
          key: rowData === null || rowData === void 0 ? void 0 : rowData.id
        }, /*#__PURE__*/React__default.createElement("img", {
          src: rowData === null || rowData === void 0 ? void 0 : rowData.url,
          style: {
            maxWidth: 300,
            margin: '6px 12px'
          }
        })));
      case 'nosupport':
        return renderZaloNosupport(rowData, index);
      default:
        return /*#__PURE__*/React__default.createElement("div", {
          key: index
        }, renderTime(rowData, index), /*#__PURE__*/React__default.createElement("div", {
          style: {
            display: 'flex',
            justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style10 = rowData.style) === null || _rowData$style10 === void 0 ? void 0 : _rowData$style10.justifyContent
          },
          key: rowData === null || rowData === void 0 ? void 0 : rowData.id
        }, /*#__PURE__*/React__default.createElement(Space, {
          style: {
            margin: '6px 12px',
            color: '#888'
          }
        }, /*#__PURE__*/React__default.createElement(WarningOutlined$2, {
          style: {
            fontSize: 20
          }
        }), /*#__PURE__*/React__default.createElement("div", null, "N\u1ED9i dung kh\xF4ng h\u1ED7 tr\u1EE3"))));
    }
  };
  var renderFacebookAttachment = function renderFacebookAttachment(attachment, style) {
    var _attachment$mime_type, _attachment$mime_type2, _attachment$image_dat, _attachment$image_dat2;
    var type = attachment === null || attachment === void 0 ? void 0 : (_attachment$mime_type = attachment.mime_type) === null || _attachment$mime_type === void 0 ? void 0 : (_attachment$mime_type2 = _attachment$mime_type.split('/')) === null || _attachment$mime_type2 === void 0 ? void 0 : _attachment$mime_type2[0];
    switch (type) {
      case 'image':
        return /*#__PURE__*/React__default.createElement(Image, {
          preview: {
            src: attachment === null || attachment === void 0 ? void 0 : (_attachment$image_dat = attachment.image_data) === null || _attachment$image_dat === void 0 ? void 0 : _attachment$image_dat.url
          },
          src: attachment === null || attachment === void 0 ? void 0 : (_attachment$image_dat2 = attachment.image_data) === null || _attachment$image_dat2 === void 0 ? void 0 : _attachment$image_dat2.preview_url,
          style: _extends({
            maxWidth: 160,
            marginRight: 4,
            objectFit: 'cover'
          }, style, {
            backgroundColor: 'transparent'
          })
        });
      case 'application':
        style = _extends({}, style, {
          cursor: 'pointer',
          padding: '4px 8px',
          borderRadius: 12
        });
        return /*#__PURE__*/React__default.createElement("a", {
          href: attachment === null || attachment === void 0 ? void 0 : attachment.file_url
        }, /*#__PURE__*/React__default.createElement(Space, {
          style: style
        }, /*#__PURE__*/React__default.createElement("div", {
          style: {
            display: 'flex',
            alignItems: 'center',
            justifyContent: 'center',
            width: 36,
            height: 36,
            borderRadius: 18,
            backgroundColor: '#fff'
          }
        }, /*#__PURE__*/React__default.createElement(FileTextOutlined$2, {
          style: {
            fontSize: 16,
            color: '#136DFB'
          }
        })), /*#__PURE__*/React__default.createElement("div", {
          style: {
            textDecoration: 'underline'
          }
        }, attachment === null || attachment === void 0 ? void 0 : attachment.name)));
      default:
        return null;
    }
  };
  var renderMessageFacebookByType = function renderMessageFacebookByType(rowData, index) {
    var _rowData$style16;
    if (rowData !== null && rowData !== void 0 && rowData.message) {
      var _rowData$style11;
      return /*#__PURE__*/React__default.createElement("div", {
        key: index
      }, renderTime(rowData, index, 'created_time'), /*#__PURE__*/React__default.createElement("div", {
        style: {
          display: 'flex',
          justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style11 = rowData.style) === null || _rowData$style11 === void 0 ? void 0 : _rowData$style11.justifyContent
        },
        key: rowData === null || rowData === void 0 ? void 0 : rowData.id
      }, /*#__PURE__*/React__default.createElement("div", {
        style: _extends({
          padding: '4px 8px',
          borderRadius: 12,
          whiteSpace: 'pre-wrap',
          overflowWrap: 'break-word',
          maxWidth: 320
        }, rowData === null || rowData === void 0 ? void 0 : rowData.style, messageStyle)
      }, "" + (rowData === null || rowData === void 0 ? void 0 : rowData.message))));
    } else if (rowData !== null && rowData !== void 0 && rowData.sticker) {
      var _rowData$style12;
      return /*#__PURE__*/React__default.createElement("div", {
        key: index
      }, renderTime(rowData, index, 'created_time'), /*#__PURE__*/React__default.createElement("div", {
        style: {
          display: 'flex',
          justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style12 = rowData.style) === null || _rowData$style12 === void 0 ? void 0 : _rowData$style12.justifyContent
        },
        key: rowData === null || rowData === void 0 ? void 0 : rowData.id
      }, /*#__PURE__*/React__default.createElement("div", {
        style: {
          padding: '4px 8px',
          maxWidth: 160
        }
      }, /*#__PURE__*/React__default.createElement("img", {
        src: rowData === null || rowData === void 0 ? void 0 : rowData.sticker,
        style: {
          maxWidth: 160
        }
      }))));
    } else if (rowData !== null && rowData !== void 0 && rowData.attachments) {
      var _rowData$style13, _rowData$attachments, _rowData$attachments$;
      return /*#__PURE__*/React__default.createElement("div", {
        key: index
      }, renderTime(rowData, index, 'created_time'), /*#__PURE__*/React__default.createElement("div", {
        style: {
          display: 'flex',
          justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style13 = rowData.style) === null || _rowData$style13 === void 0 ? void 0 : _rowData$style13.justifyContent
        },
        key: rowData === null || rowData === void 0 ? void 0 : rowData.id
      }, /*#__PURE__*/React__default.createElement("div", null, rowData === null || rowData === void 0 ? void 0 : (_rowData$attachments = rowData.attachments) === null || _rowData$attachments === void 0 ? void 0 : (_rowData$attachments$ = _rowData$attachments.data) === null || _rowData$attachments$ === void 0 ? void 0 : _rowData$attachments$.map(function (e, i) {
        var _rowData$style14, _rowData$style15;
        return /*#__PURE__*/React__default.createElement("div", {
          key: i,
          style: _extends({
            padding: '4px 8px'
          }, rowData === null || rowData === void 0 ? void 0 : rowData.style, {
            margin: 0,
            backgroundColor: 'transparent'
          }, messageStyle)
        }, renderFacebookAttachment(e, {
          color: rowData === null || rowData === void 0 ? void 0 : (_rowData$style14 = rowData.style) === null || _rowData$style14 === void 0 ? void 0 : _rowData$style14.color,
          backgroundColor: rowData === null || rowData === void 0 ? void 0 : (_rowData$style15 = rowData.style) === null || _rowData$style15 === void 0 ? void 0 : _rowData$style15.backgroundColor
        }));
      }))));
    }
    return /*#__PURE__*/React__default.createElement("div", {
      key: index
    }, renderTime(rowData, index), /*#__PURE__*/React__default.createElement("div", {
      style: {
        display: 'flex',
        justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style16 = rowData.style) === null || _rowData$style16 === void 0 ? void 0 : _rowData$style16.justifyContent
      },
      key: rowData === null || rowData === void 0 ? void 0 : rowData.id
    }, /*#__PURE__*/React__default.createElement(Space, {
      style: {
        margin: '6px 12px',
        color: '#888'
      }
    }, /*#__PURE__*/React__default.createElement(WarningOutlined$2, {
      style: {
        fontSize: 20
      }
    }), /*#__PURE__*/React__default.createElement("div", null, "N\u1ED9i dung kh\xF4ng h\u1ED7 tr\u1EE3"))));
  };
  return /*#__PURE__*/React__default.createElement("div", {
    style: {
      flex: 1,
      overflowY: 'auto'
    },
    onScroll: handleScroll,
    ref: messagesRef
  }, /*#__PURE__*/React__default.createElement("div", {
    style: {
      display: 'flex',
      flexFlow: 'column',
      height: '100%',
      width: '100%'
    }
  }, type === CONST.CONVERSATION_TYPE.ZALO ? messages.map(function (e, i) {
    return renderMessageZaloByType(e, i);
  }) : messages.map(function (e, i) {
    return renderMessageFacebookByType(e, i);
  }), /*#__PURE__*/React__default.createElement("div", {
    ref: bottomRef
  })));
});

var styles$1 = {"chat-file-item":"_2X3uH","chat-file-item-img":"_329j9","chat-file-item-delete":"_ppteR"};

var styleFrom = {
  backgroundColor: '#f1f1f1',
  color: '#000',
  justifyContent: 'flex-start',
  margin: '6px 48px 6px 12px'
};
var styleMe = {
  backgroundColor: '#136DFB',
  color: '#fff',
  justifyContent: 'flex-end',
  margin: '6px 12px 6px 48px'
};
var FbConversationDetail = function FbConversationDetail(props) {
  var _props$style = props.style,
    style = _props$style === void 0 ? {} : _props$style,
    _props$messageStyle = props.messageStyle,
    messageStyle = _props$messageStyle === void 0 ? {} : _props$messageStyle,
    shopId = props.shopId,
    pageId = props.pageId,
    conversation = props.conversation,
    _props$actionGetFbCon = props.actionGetFbConversationDetail,
    actionGetFbConversationDetail = _props$actionGetFbCon === void 0 ? function () {} : _props$actionGetFbCon,
    _props$type = props.type,
    type = _props$type === void 0 ? CONST.CONVERSATION_TYPE.MESSENGER : _props$type,
    _props$showChatHeader = props.showChatHeader,
    showChatHeader = _props$showChatHeader === void 0 ? false : _props$showChatHeader,
    _props$tag = props.tag,
    tag = _props$tag === void 0 ? [] : _props$tag,
    _props$socket = props.socket,
    socket = _props$socket === void 0 ? null : _props$socket,
    _props$actionSendMess = props.actionSendMessage,
    actionSendMessage = _props$actionSendMess === void 0 ? function () {} : _props$actionSendMess,
    _props$fileMaxHeight = props.fileMaxHeight,
    fileMaxHeight = _props$fileMaxHeight === void 0 ? 250 : _props$fileMaxHeight;
  var messagesRef = useRef(null);
  var fileInputRef = useRef();
  var _useState = useState({
      next: 'init'
    }),
    messagePaging = _useState[0],
    setMessagePaging = _useState[1];
  var _useState2 = useState(false),
    fetchingData = _useState2[0],
    setFetchingData = _useState2[1];
  var _useState3 = useState(10),
    startIndex = _useState3[0];
  var _useState4 = useState(true),
    firstFetchingMessages = _useState4[0],
    setFirstFetchingMessages = _useState4[1];
  var _useState5 = useState({
      shopId: shopId,
      conversationId: 0,
      pageId: pageId
    }),
    conversationDetailParams = _useState5[0],
    setConversationDetailParams = _useState5[1];
  var _useState6 = useState(),
    conversationDetail = _useState6[0],
    setConversationDetail = _useState6[1];
  var _useState7 = useState([]),
    messages = _useState7[0],
    setMessages = _useState7[1];
  var _useState8 = useState(),
    webhookMessage = _useState8[0],
    setWebhookMessage = _useState8[1];
  var _useState9 = useState(false),
    isChatSending = _useState9[0],
    setIsChatSending = _useState9[1];
  var _useState10 = useState(''),
    chatContent = _useState10[0],
    setChatContent = _useState10[1];
  var _useState11 = useState([]),
    files = _useState11[0],
    setFiles = _useState11[1];
  useEffect(function () {
    handleConversation();
  }, [conversation]);
  useEffect(function () {
    getConversationDetail();
  }, [conversationDetailParams]);
  useEffect(function () {
    if (socket) {
      socket.on(CONST.EVENT.WEBHOOK_FACEBOOK, function (event) {
        setWebhookMessage(function () {
          return event;
        });
      });
    }
  }, [socket]);
  useEffect(function () {
    if (webhookMessage) {
      handleWebhookMessage(webhookMessage);
    }
  }, [webhookMessage]);
  var handleConversation = function handleConversation() {
    var _conversation$partici, _conversation$partici2;
    var partner = conversation === null || conversation === void 0 ? void 0 : (_conversation$partici = conversation.participants) === null || _conversation$partici === void 0 ? void 0 : (_conversation$partici2 = _conversation$partici.data) === null || _conversation$partici2 === void 0 ? void 0 : _conversation$partici2[0];
    var displayName = (partner === null || partner === void 0 ? void 0 : partner.name) || '';
    var displayAvatar = (partner === null || partner === void 0 ? void 0 : partner.urlAvatar) || '';
    var fbChatUserId = (partner === null || partner === void 0 ? void 0 : partner.id) || '';
    var chatId = (conversation === null || conversation === void 0 ? void 0 : conversation.id) || '';
    var _conversation = _extends({
      displayName: displayName,
      displayAvatar: displayAvatar,
      message: (conversation === null || conversation === void 0 ? void 0 : conversation.message) || '',
      time: (conversation === null || conversation === void 0 ? void 0 : conversation.updated_time) || 0,
      chatId: chatId,
      fbChatUserId: fbChatUserId
    }, conversation);
    setMessagePaging({
      next: 'init'
    });
    setFirstFetchingMessages(true);
    setConversationDetail(_conversation);
    setConversationDetailParams(_extends({}, conversationDetailParams, {
      conversationId: _conversation === null || _conversation === void 0 ? void 0 : _conversation.chatId,
      pageId: pageId,
      after: null
    }));
    console.log('_conversation -----> ', _conversation);
  };
  var getConversationDetail = function getConversationDetail() {
    try {
      var _temp = function () {
        if (conversationDetail !== null && conversationDetail !== void 0 && conversationDetail.chatId && (!messagePaging || messagePaging !== null && messagePaging !== void 0 && messagePaging.next) && !fetchingData) {
          setFetchingData(true);
          return Promise.resolve(actionGetFbConversationDetail(conversationDetailParams)).then(function (res) {
            var _res$data, _res$data$data, _res$data2, _res$data2$data;
            console.log('getConversationDetail', res);
            var _messages = (res === null || res === void 0 ? void 0 : (_res$data = res.data) === null || _res$data === void 0 ? void 0 : (_res$data$data = _res$data.data) === null || _res$data$data === void 0 ? void 0 : _res$data$data.data) || [];
            _messages.reverse();
            _messages = _messages.map(function (e) {
              return _extends({}, e, {
                style: (e === null || e === void 0 ? void 0 : e.fromId) === (conversationDetail === null || conversationDetail === void 0 ? void 0 : conversationDetail.fbChatUserId) ? styleFrom : styleMe
              });
            });
            if (conversationDetailParams !== null && conversationDetailParams !== void 0 && conversationDetailParams.after) {
              setMessages([].concat(_messages, messages));
            } else {
              setMessages(_messages);
            }
            var paging = res === null || res === void 0 ? void 0 : (_res$data2 = res.data) === null || _res$data2 === void 0 ? void 0 : (_res$data2$data = _res$data2.data) === null || _res$data2$data === void 0 ? void 0 : _res$data2$data.paging;
            setMessagePaging(paging);
            setFetchingData(false);
            setFirstFetchingMessages(false);
          });
        }
      }();
      return Promise.resolve(_temp && _temp.then ? _temp.then(function () {}) : void 0);
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var startReached = function startReached() {
    var _messagePaging$cursor;
    setConversationDetailParams(_extends({}, conversationDetailParams, {
      after: (_messagePaging$cursor = messagePaging.cursors) === null || _messagePaging$cursor === void 0 ? void 0 : _messagePaging$cursor.after
    }));
  };
  var sendMessage = function sendMessage() {
    try {
      var formData = new FormData();
      files.forEach(function (e) {
        formData.append("files", e);
      });
      formData.append("message", chatContent || '');
      formData.append("userId", conversationDetail === null || conversationDetail === void 0 ? void 0 : conversationDetail.fbChatUserId);
      formData.append("shopId", shopId);
      formData.append("pageId", pageId);
      var _temp2 = function () {
        if (chatContent || files !== null && files !== void 0 && files.length) {
          setIsChatSending(true);
          setChatContent('');
          setFiles([]);
          return Promise.resolve(actionSendMessage(null, formData)).then(function () {});
        }
      }();
      return Promise.resolve(_temp2 && _temp2.then ? _temp2.then(function () {}) : void 0);
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var handleWebhookMessage = function handleWebhookMessage(event) {
    console.log('webhook_facebook', event);
    if (conversationDetail.chatId === (event === null || event === void 0 ? void 0 : event.conversationId)) {
      console.log('-----> 2');
      var attachments = null;
      if (event !== null && event !== void 0 && event.attachments) {
        var _event$attachments;
        var data = event === null || event === void 0 ? void 0 : (_event$attachments = event.attachments) === null || _event$attachments === void 0 ? void 0 : _event$attachments.map(function (e) {
          return _extends({}, e, {
            image_data: {
              preview_url: e === null || e === void 0 ? void 0 : e.url,
              url: e === null || e === void 0 ? void 0 : e.url
            }
          });
        });
        attachments = {
          data: data
        };
        console.log('attachments', attachments);
      }
      var newMessage = _extends({}, event, {
        attachments: attachments,
        id: event === null || event === void 0 ? void 0 : event.mid,
        created_time: event === null || event === void 0 ? void 0 : event.createdTime,
        style: (event === null || event === void 0 ? void 0 : event.toId) === pageId ? styleFrom : styleMe
      });
      console.log('newMessage', newMessage);
      setMessages([].concat(messages, [newMessage]));
      setIsChatSending(false);
      console.log('-----> 4');
    }
  };
  var handleChange = function handleChange(event) {
    var _event$target, _event$target2;
    console.log('files', (_event$target = event.target) === null || _event$target === void 0 ? void 0 : _event$target.files);
    setFiles(Array.from((_event$target2 = event.target) === null || _event$target2 === void 0 ? void 0 : _event$target2.files));
  };
  var removeFileItem = function removeFileItem(item, index) {
    files.splice(index, 1);
    setFiles([].concat(files));
  };
  return /*#__PURE__*/React__default.createElement("div", {
    style: _extends({
      flex: 1,
      display: 'flex',
      flexDirection: 'column',
      minWidth: 300,
      height: '100%'
    }, style)
  }, showChatHeader ? /*#__PURE__*/React__default.createElement("div", {
    style: {
      padding: 12,
      height: 64,
      width: '100%'
    },
    className: "box-shadow"
  }, /*#__PURE__*/React__default.createElement("div", {
    style: {
      display: 'inline-flex',
      alignItems: 'center'
    }
  }, /*#__PURE__*/React__default.createElement("img", {
    src: conversationDetail === null || conversationDetail === void 0 ? void 0 : conversationDetail.displayAvatar,
    style: {
      width: 40,
      height: 40,
      borderRadius: 20,
      objectFit: 'cover',
      backgroundColor: '#f1f1f1'
    }
  }), /*#__PURE__*/React__default.createElement("div", {
    style: {
      marginLeft: 12
    }
  }, /*#__PURE__*/React__default.createElement("div", null, conversationDetail === null || conversationDetail === void 0 ? void 0 : conversationDetail.displayName), /*#__PURE__*/React__default.createElement(Space, {
    size: 0,
    style: {
      marginTop: 4
    }
  }, tag === null || tag === void 0 ? void 0 : tag.map(function (e) {
    return /*#__PURE__*/React__default.createElement(Tag, {
      color: e === null || e === void 0 ? void 0 : e.color
    }, e === null || e === void 0 ? void 0 : e.name);
  }))))) : null, firstFetchingMessages && !(conversationDetailParams !== null && conversationDetailParams !== void 0 && conversationDetailParams.page) ? /*#__PURE__*/React__default.createElement("div", {
    style: {
      flex: 1,
      padding: 24
    }
  }, /*#__PURE__*/React__default.createElement(Skeleton, {
    loading: true,
    active: true,
    avatar: true
  }), /*#__PURE__*/React__default.createElement(Skeleton, {
    loading: true,
    active: true,
    avatar: true
  }), /*#__PURE__*/React__default.createElement(Skeleton, {
    loading: true,
    active: true,
    avatar: true
  })) : /*#__PURE__*/React__default.createElement(Fragment, null, /*#__PURE__*/React__default.createElement(MessagesRender, {
    ref: messagesRef,
    messages: messages,
    startReached: startReached,
    START_INDEX: startIndex,
    type: type,
    isChatSending: isChatSending,
    messageStyle: messageStyle
  }), isChatSending ? /*#__PURE__*/React__default.createElement("div", {
    style: {
      color: '#999',
      fontSize: 12,
      textAlign: 'center',
      padding: 4
    }
  }, "\u0110ang g\u1EEDi") : null, /*#__PURE__*/React__default.createElement("div", {
    style: {
      maxHeight: fileMaxHeight,
      overflowY: 'auto',
      borderTop: '1px solid #eee'
    }
  }, files === null || files === void 0 ? void 0 : files.map(function (e, i) {
    return /*#__PURE__*/React__default.createElement("div", {
      key: e === null || e === void 0 ? void 0 : e.name,
      className: styles$1['chat-file-item']
    }, /*#__PURE__*/React__default.createElement("div", {
      className: styles$1['chat-file-item-img']
    }, (e === null || e === void 0 ? void 0 : e.type.indexOf('image')) > -1 ? /*#__PURE__*/React__default.createElement(FileImageOutlined$2, null) : /*#__PURE__*/React__default.createElement(PaperClipOutlined$2, null)), /*#__PURE__*/React__default.createElement("div", {
      style: {
        flex: 1,
        marginLeft: 12
      }
    }, e === null || e === void 0 ? void 0 : e.name), /*#__PURE__*/React__default.createElement(CloseOutlined$2, {
      className: styles$1['chat-file-item-delete'],
      onClick: function onClick() {
        return removeFileItem(e, i);
      }
    }));
  })), /*#__PURE__*/React__default.createElement("div", {
    style: {
      padding: 8,
      display: 'flex',
      flexDirection: 'row',
      alignItems: 'flex-end'
    }
  }, /*#__PURE__*/React__default.createElement(Input.TextArea, {
    placeholder: "Nh\u1EADp n\u1ED9i dung",
    value: chatContent,
    onChange: function onChange(e) {
      var _e$target;
      return setChatContent(e === null || e === void 0 ? void 0 : (_e$target = e.target) === null || _e$target === void 0 ? void 0 : _e$target.value);
    },
    autoSize: {
      minRows: 1,
      maxRows: 6
    },
    style: {
      flex: 1
    }
  }), /*#__PURE__*/React__default.createElement(PaperClipOutlined$2, {
    style: {
      fontSize: 24,
      paddingLeft: 12,
      paddingBottom: 4,
      color: '#136DFB'
    },
    onClick: function onClick() {
      return fileInputRef.current.click();
    }
  }), /*#__PURE__*/React__default.createElement("input", {
    onChange: handleChange,
    multiple: true,
    ref: fileInputRef,
    type: "file",
    hidden: true
  }), /*#__PURE__*/React__default.createElement(SendOutlined$2, {
    style: {
      fontSize: 22,
      paddingLeft: 12,
      paddingBottom: 4,
      color: '#136DFB'
    },
    onClick: sendMessage
  }))));
};

var ZaloConversations = function ZaloConversations(props) {
  var shopId = props.shopId,
    _props$actionGetListC = props.actionGetListConversation,
    actionGetListConversation = _props$actionGetListC === void 0 ? function () {} : _props$actionGetListC,
    _props$onSelectConver = props.onSelectConversation,
    onSelectConversation = _props$onSelectConver === void 0 ? function () {} : _props$onSelectConver,
    _props$fetchingDone = props.fetchingDone,
    fetchingDone = _props$fetchingDone === void 0 ? function () {} : _props$fetchingDone,
    _props$tags = props.tags,
    tags = _props$tags === void 0 ? {} : _props$tags,
    _props$socket = props.socket,
    socket = _props$socket === void 0 ? null : _props$socket;
  var _useState = useState(true),
    fetchingConversations = _useState[0],
    setFetchingConversations = _useState[1];
  var _useState2 = useState(false),
    loadConversations = _useState2[0],
    setLoadConversations = _useState2[1];
  var _useState3 = useState(),
    conversation = _useState3[0],
    setConversation = _useState3[1];
  var _useState4 = useState([]),
    conversations = _useState4[0],
    setConversations = _useState4[1];
  var _useState5 = useState(true),
    isNextPageConversations = _useState5[0],
    setIsNextPageConversations = _useState5[1];
  var _useState6 = useState({
      shopId: shopId,
      page: 0,
      pageSize: 10
    }),
    conversationsParams = _useState6[0],
    setConversationsParams = _useState6[1];
  var _useState7 = useState(true),
    setIsNextPage = _useState7[1];
  useEffect(function () {
    getListConversation();
  }, [conversationsParams]);
  useEffect(function () {
    console.log('useEffect socket', socket);
    if (socket !== null && socket !== void 0 && socket.id && socket !== null && socket !== void 0 && socket.connected) {
      socket.on(CONST.EVENT.WEBHOOK_ZALO, function (event) {
        console.log('socket WEBHOOK_ZALO');
        handleWebhookMessage(event);
      });
    }
  }, [socket]);
  var getListConversation = function getListConversation() {
    try {
      setLoadConversations(true);
      return Promise.resolve(actionGetListConversation(conversationsParams)).then(function (res) {
        var _res$data, _res$data$data;
        console.log('actionGetListConversation', res);
        var resDatas = (res === null || res === void 0 ? void 0 : (_res$data = res.data) === null || _res$data === void 0 ? void 0 : (_res$data$data = _res$data.data) === null || _res$data$data === void 0 ? void 0 : _res$data$data.data) || [];
        var _conversations = [];
        if ((resDatas === null || resDatas === void 0 ? void 0 : resDatas.length) < conversationsParams.pageSize) {
          setIsNextPageConversations(false);
        }
        resDatas.forEach(function (e) {
          var displayName = (e === null || e === void 0 ? void 0 : e.to_display_name) || '';
          var displayAvatar = (e === null || e === void 0 ? void 0 : e.to_avatar) || '';
          var chatId = (e === null || e === void 0 ? void 0 : e.to_id) || '';
          if (e !== null && e !== void 0 && e.src) {
            displayName = (e === null || e === void 0 ? void 0 : e.from_display_name) || '';
            displayAvatar = (e === null || e === void 0 ? void 0 : e.from_avatar) || '';
            chatId = (e === null || e === void 0 ? void 0 : e.from_id) || '';
          }
          _conversations.push({
            displayName: displayName,
            displayAvatar: displayAvatar,
            message: (e === null || e === void 0 ? void 0 : e.message) || '',
            time: (e === null || e === void 0 ? void 0 : e.time) || 0,
            chatId: chatId
          });
        });
        if (conversationsParams.page > 0) {
          setConversations([].concat(conversations, _conversations));
        } else {
          setConversations(_conversations);
          selectConversation(_conversations === null || _conversations === void 0 ? void 0 : _conversations[0]);
        }
        setLoadConversations(false);
        setFetchingConversations(false);
        fetchingDone(_conversations);
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var selectConversation = function selectConversation(_conversation) {
    console.log('_conversation', _conversation);
    if ((_conversation === null || _conversation === void 0 ? void 0 : _conversation.chatId) !== (conversation === null || conversation === void 0 ? void 0 : conversation.chatId)) {
      setIsNextPage(true);
      setConversation(_conversation);
      onSelectConversation(_conversation);
    }
  };
  var handleScroll = function handleScroll(event) {
    var scrollTop = event.currentTarget.scrollTop;
    var scrollHeight = event.currentTarget.scrollHeight;
    var offsetHeight = event.currentTarget.offsetHeight;
    var scrollBottom = scrollHeight - offsetHeight - scrollTop;
    if (scrollBottom < 50 && !loadConversations) {
      console.log('bottom');
      if (isNextPageConversations) {
        setConversationsParams(_extends({}, conversationsParams, {
          page: conversationsParams.page + 1
        }));
      }
    }
  };
  var handleWebhookMessage = function handleWebhookMessage(event) {
    console.log(CONST.EVENT.WEBHOOK_ZALO, event);
    setConversations(function (conversations) {
      var _event$event_name, _event$sender, _event$recipient, _event$message;
      var eventName = event === null || event === void 0 ? void 0 : (_event$event_name = event.event_name) === null || _event$event_name === void 0 ? void 0 : _event$event_name.split('_');
      var from = eventName === null || eventName === void 0 ? void 0 : eventName[0];
      var chatId = from === 'user' ? event === null || event === void 0 ? void 0 : (_event$sender = event.sender) === null || _event$sender === void 0 ? void 0 : _event$sender.id : event === null || event === void 0 ? void 0 : (_event$recipient = event.recipient) === null || _event$recipient === void 0 ? void 0 : _event$recipient.id;
      var index = conversations.findIndex(function (e) {
        return (e === null || e === void 0 ? void 0 : e.chatId) === chatId;
      });
      var conversation;
      if (index > -1) {
        var _conversations$splice;
        conversation = conversations === null || conversations === void 0 ? void 0 : (_conversations$splice = conversations.splice(index, 1)) === null || _conversations$splice === void 0 ? void 0 : _conversations$splice[0];
      } else {
        conversation = {
          chatId: chatId,
          displayAvatar: event === null || event === void 0 ? void 0 : event.zalo_user_avatar,
          displayName: event === null || event === void 0 ? void 0 : event.zalo_user_display_name
        };
      }
      var insert = _extends({}, conversation, event, {
        time: event === null || event === void 0 ? void 0 : event.timestamp,
        message: event === null || event === void 0 ? void 0 : (_event$message = event.message) === null || _event$message === void 0 ? void 0 : _event$message.text
      });
      console.log('data', insert);
      return [insert].concat(conversations);
    });
  };
  return fetchingConversations ? /*#__PURE__*/React__default.createElement("div", {
    style: {
      padding: 24
    }
  }, /*#__PURE__*/React__default.createElement(Skeleton, {
    loading: true,
    active: true,
    avatar: true
  }), /*#__PURE__*/React__default.createElement(Skeleton, {
    loading: true,
    active: true,
    avatar: true
  }), /*#__PURE__*/React__default.createElement(Skeleton, {
    loading: true,
    active: true,
    avatar: true
  })) : /*#__PURE__*/React__default.createElement("div", {
    onScroll: handleScroll,
    style: {
      display: 'flex',
      flexFlow: 'column',
      overflowY: 'auto',
      marginLeft: 12,
      marginTop: 12
    }
  }, conversations === null || conversations === void 0 ? void 0 : conversations.map(function (e, i) {
    var _moment$fromNow, _moment$fromNow$repla, _tags$e$chatId;
    return /*#__PURE__*/React__default.createElement("div", {
      style: {
        display: 'inline-flex',
        padding: 12,
        cursor: 'pointer',
        borderRadius: 6,
        marginRight: 6,
        backgroundColor: (e === null || e === void 0 ? void 0 : e.chatId) === (conversation === null || conversation === void 0 ? void 0 : conversation.chatId) ? '#f1f1f1' : 'transparent'
      },
      onClick: function onClick() {
        return selectConversation(e);
      },
      key: i
    }, /*#__PURE__*/React__default.createElement("img", {
      src: e === null || e === void 0 ? void 0 : e.displayAvatar,
      style: {
        width: 40,
        height: 40,
        borderRadius: 20,
        objectFit: 'cover',
        backgroundColor: '#f1f1f1'
      }
    }), /*#__PURE__*/React__default.createElement("div", {
      style: {
        marginLeft: 12
      }
    }, /*#__PURE__*/React__default.createElement("div", null, e === null || e === void 0 ? void 0 : e.displayName), /*#__PURE__*/React__default.createElement("div", {
      style: {
        display: 'flex',
        flexDirection: 'row',
        alignItems: 'center',
        fontSize: 12,
        color: '#999',
        marginTop: 2
      }
    }, e !== null && e !== void 0 && e.message ? /*#__PURE__*/React__default.createElement(Fragment, null, /*#__PURE__*/React__default.createElement("div", {
      style: {
        maxWidth: 120,
        'white-space': 'nowrap',
        'text-overflow': 'ellipsis',
        overflow: 'hidden'
      }
    }, e === null || e === void 0 ? void 0 : e.message), /*#__PURE__*/React__default.createElement("div", {
      style: {
        width: 2,
        height: 2,
        backgroundColor: '#ccc',
        borderRadius: 2,
        margin: '0px 4px'
      }
    })) : null, /*#__PURE__*/React__default.createElement("div", null, (_moment$fromNow = moment(e === null || e === void 0 ? void 0 : e.time).fromNow()) === null || _moment$fromNow === void 0 ? void 0 : (_moment$fromNow$repla = _moment$fromNow.replace('trước', '')) === null || _moment$fromNow$repla === void 0 ? void 0 : _moment$fromNow$repla.trim())), /*#__PURE__*/React__default.createElement(Space, {
      size: 0,
      style: {
        marginTop: 4
      }
    }, tags === null || tags === void 0 ? void 0 : (_tags$e$chatId = tags[e === null || e === void 0 ? void 0 : e.chatId]) === null || _tags$e$chatId === void 0 ? void 0 : _tags$e$chatId.map(function (e) {
      return /*#__PURE__*/React__default.createElement(Tag, {
        color: e === null || e === void 0 ? void 0 : e.color
      }, e === null || e === void 0 ? void 0 : e.name);
    }))));
  }));
};

var styleFrom$1 = {
  backgroundColor: '#f1f1f1',
  color: '#000',
  justifyContent: 'flex-start',
  margin: '6px 48px 6px 12px'
};
var styleMe$1 = {
  backgroundColor: '#136DFB',
  color: '#fff',
  justifyContent: 'flex-end',
  margin: '6px 12px 6px 48px'
};
var ZaloConversationDetail = function ZaloConversationDetail(props) {
  var _props$style = props.style,
    style = _props$style === void 0 ? {} : _props$style,
    _props$messageStyle = props.messageStyle,
    messageStyle = _props$messageStyle === void 0 ? {} : _props$messageStyle,
    shopId = props.shopId,
    _props$showChatHeader = props.showChatHeader,
    showChatHeader = _props$showChatHeader === void 0 ? false : _props$showChatHeader,
    conversation = props.conversation,
    _props$actionGetConve = props.actionGetConversationDetail,
    actionGetConversationDetail = _props$actionGetConve === void 0 ? function () {} : _props$actionGetConve,
    _props$tag = props.tag,
    tag = _props$tag === void 0 ? [] : _props$tag,
    _props$actionSendMess = props.actionSendMessage,
    actionSendMessage = _props$actionSendMess === void 0 ? function () {} : _props$actionSendMess,
    _props$actionGetShopC = props.actionGetShopCustomerByChatId,
    actionGetShopCustomerByChatId = _props$actionGetShopC === void 0 ? function () {} : _props$actionGetShopC,
    _props$socket = props.socket,
    socket = _props$socket === void 0 ? null : _props$socket,
    _props$fileMaxHeight = props.fileMaxHeight,
    fileMaxHeight = _props$fileMaxHeight === void 0 ? 250 : _props$fileMaxHeight;
  var messagesRef = useRef(null);
  var fileInputRef = useRef();
  var _useState = useState({
      next: 'init'
    });
  var _useState2 = useState(false),
    fetchingData = _useState2[0],
    setFetchingData = _useState2[1];
  var _useState3 = useState(10),
    startIndex = _useState3[0],
    setStartIndex = _useState3[1];
  var _useState4 = useState(true);
  var _useState5 = useState({
      shopId: shopId,
      page: 0,
      pageSize: 10
    }),
    conversationDetailParams = _useState5[0],
    setConversationDetailParams = _useState5[1];
  var _useState6 = useState(),
    conversationDetail = _useState6[0],
    setConversationDetail = _useState6[1];
  var _useState7 = useState([]),
    messages = _useState7[0],
    setMessages = _useState7[1];
  var _useState8 = useState(),
    webhookMessage = _useState8[0],
    setWebhookMessage = _useState8[1];
  var _useState9 = useState(true),
    isNextPage = _useState9[0],
    setIsNextPage = _useState9[1];
  var _useState10 = useState(),
    shopCustomer = _useState10[0],
    setShopCustomer = _useState10[1];
  var _useState11 = useState(''),
    chatContent = _useState11[0],
    setChatContent = _useState11[1];
  var _useState12 = useState(false),
    isChatSending = _useState12[0],
    setIsChatSending = _useState12[1];
  var _useState13 = useState([]),
    files = _useState13[0],
    setFiles = _useState13[1];
  useEffect(function () {
    handleConversation();
  }, [conversation]);
  useEffect(function () {
    getConversationDetail();
  }, [conversationDetailParams]);
  useEffect(function () {
    if (socket) {
      socket.on(CONST.EVENT.WEBHOOK_ZALO, function (event) {
        setWebhookMessage(function () {
          return event;
        });
      });
    }
  }, [socket]);
  useEffect(function () {
    if (webhookMessage) {
      handleWebhookMessage(webhookMessage);
    }
  }, [webhookMessage]);
  var handleConversation = function handleConversation() {
    var displayName = (conversation === null || conversation === void 0 ? void 0 : conversation.to_display_name) || '';
    var displayAvatar = (conversation === null || conversation === void 0 ? void 0 : conversation.to_avatar) || '';
    var chatId = (conversation === null || conversation === void 0 ? void 0 : conversation.to_id) || '';
    if (conversation !== null && conversation !== void 0 && conversation.src) {
      displayName = (conversation === null || conversation === void 0 ? void 0 : conversation.from_display_name) || '';
      displayAvatar = (conversation === null || conversation === void 0 ? void 0 : conversation.from_avatar) || '';
      chatId = (conversation === null || conversation === void 0 ? void 0 : conversation.from_id) || '';
    }
    var _conversation = _extends({
      displayName: displayName,
      displayAvatar: displayAvatar,
      message: (conversation === null || conversation === void 0 ? void 0 : conversation.message) || '',
      time: (conversation === null || conversation === void 0 ? void 0 : conversation.time) || 0,
      chatId: chatId
    }, conversation);
    setIsNextPage(true);
    setConversationDetail(_conversation);
    setConversationDetailParams(_extends({}, conversationDetailParams, {
      page: 0,
      userOAId: _conversation === null || _conversation === void 0 ? void 0 : _conversation.chatId
    }));
    getShopCustomer(_conversation === null || _conversation === void 0 ? void 0 : _conversation.chatId);
  };
  var getConversationDetail = function getConversationDetail() {
    try {
      var _temp = function () {
        if (conversationDetail !== null && conversationDetail !== void 0 && conversationDetail.chatId && isNextPage) {
          setFetchingData(true);
          console.log('conversationDetailParams', conversationDetailParams);
          return Promise.resolve(actionGetConversationDetail(conversationDetailParams)).then(function (res) {
            var _res$data, _messages2;
            console.log('getConversationDetail', res);
            var _messages = (res === null || res === void 0 ? void 0 : (_res$data = res.data) === null || _res$data === void 0 ? void 0 : _res$data.data) || [];
            if (((_messages2 = _messages) === null || _messages2 === void 0 ? void 0 : _messages2.length) < 10) {
              setIsNextPage(false);
            }
            _messages.reverse();
            _messages = _messages.map(function (e) {
              return _extends({}, e, {
                style: e !== null && e !== void 0 && e.src ? styleFrom$1 : styleMe$1
              });
            });
            console.log('_messages', _messages);
            if (conversationDetailParams !== null && conversationDetailParams !== void 0 && conversationDetailParams.page) {
              setMessages([].concat(_messages, messages));
            } else {
              var _messages3;
              setMessages(_messages);
              setStartIndex((_messages3 = _messages) === null || _messages3 === void 0 ? void 0 : _messages3.length);
            }
            setFetchingData(false);
          });
        }
      }();
      return Promise.resolve(_temp && _temp.then ? _temp.then(function () {}) : void 0);
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var startReached = function startReached() {
    if (!fetchingData) {
      setConversationDetailParams(_extends({}, conversationDetailParams, {
        page: conversationDetailParams.page + 1
      }));
    }
  };
  var getShopCustomer = function getShopCustomer(chatId) {
    try {
      console.log('getShopCustomer', chatId);
      return Promise.resolve(actionGetShopCustomerByChatId(shopId, chatId)).then(function (res) {
        var _res$data2;
        setShopCustomer(res === null || res === void 0 ? void 0 : (_res$data2 = res.data) === null || _res$data2 === void 0 ? void 0 : _res$data2.data);
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var buildMessageSend = function buildMessageSend() {
    var messageSends = [];
    if ((files === null || files === void 0 ? void 0 : files.length) > 0) {
      var formData = new FormData();
      files.forEach(function (e) {
        formData.append("files", e);
      });
      formData.append("type", 'FILE');
      formData.append("shopId", shopId);
      formData.append("customerId", (shopCustomer === null || shopCustomer === void 0 ? void 0 : shopCustomer.customerId) || null);
      messageSends.push(formData);
    }
    if (chatContent) {
      var _formData = new FormData();
      _formData.append("type", 'MESSAGE');
      _formData.append("shopId", shopId);
      _formData.append("customerId", (shopCustomer === null || shopCustomer === void 0 ? void 0 : shopCustomer.customerId) || null);
      _formData.append("message", chatContent || '');
      messageSends.push(_formData);
    }
    return messageSends;
  };
  var sendMessage = function sendMessage() {
    try {
      var messageSends = buildMessageSend();
      if (messageSends !== null && messageSends !== void 0 && messageSends.length) {
        setIsChatSending(true);
        setChatContent('');
        setFiles([]);
        messageSends.forEach(function (e) {
          try {
            return Promise.resolve(actionSendMessage(null, e)).then(function () {});
          } catch (e) {
            return Promise.reject(e);
          }
        });
      }
      return Promise.resolve();
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var handleWebhookMessage = function handleWebhookMessage(event) {
    var _event$sender, _event$recipient;
    console.log('webhook_zalo detail', event);
    if ((conversationDetail === null || conversationDetail === void 0 ? void 0 : conversationDetail.chatId) === (event === null || event === void 0 ? void 0 : (_event$sender = event.sender) === null || _event$sender === void 0 ? void 0 : _event$sender.id) || (conversationDetail === null || conversationDetail === void 0 ? void 0 : conversationDetail.chatId) === (event === null || event === void 0 ? void 0 : (_event$recipient = event.recipient) === null || _event$recipient === void 0 ? void 0 : _event$recipient.id)) {
      var _event$event_name, _event$message, _event$message$attach, _event$message$attach2, _event$message$attach3, _event$message2, _event$message2$attac, _event$message2$attac2, _event$message3, _event$message4;
      console.log('-----> 1');
      var eventName = event === null || event === void 0 ? void 0 : (_event$event_name = event.event_name) === null || _event$event_name === void 0 ? void 0 : _event$event_name.split('_');
      var from = eventName === null || eventName === void 0 ? void 0 : eventName[0];
      var type = eventName === null || eventName === void 0 ? void 0 : eventName[2];
      if (type === 'image') type = 'photo';
      if (type === 'file') type = 'nosupport';
      var url = (event === null || event === void 0 ? void 0 : (_event$message = event.message) === null || _event$message === void 0 ? void 0 : (_event$message$attach = _event$message.attachments) === null || _event$message$attach === void 0 ? void 0 : (_event$message$attach2 = _event$message$attach[0]) === null || _event$message$attach2 === void 0 ? void 0 : (_event$message$attach3 = _event$message$attach2.payload) === null || _event$message$attach3 === void 0 ? void 0 : _event$message$attach3.url) || null;
      var from_avatar, from_display_name, from_id, to_avatar, to_display_name, to_id, _style;
      if (from === 'oa') {
        var _event$sender2, _event$recipient2;
        from_avatar = event === null || event === void 0 ? void 0 : event.zalo_oa_avatar;
        from_display_name = event === null || event === void 0 ? void 0 : event.zalo_oa_display_name;
        from_id = event === null || event === void 0 ? void 0 : (_event$sender2 = event.sender) === null || _event$sender2 === void 0 ? void 0 : _event$sender2.id;
        to_avatar = event === null || event === void 0 ? void 0 : event.zalo_user_avatar;
        to_display_name = event === null || event === void 0 ? void 0 : event.zalo_user_display_name;
        to_id = event === null || event === void 0 ? void 0 : (_event$recipient2 = event.recipient) === null || _event$recipient2 === void 0 ? void 0 : _event$recipient2.id;
        _style = styleMe$1;
      } else {
        var _event$recipient3, _event$sender3;
        from_avatar = event === null || event === void 0 ? void 0 : event.zalo_user_avatar;
        from_display_name = event === null || event === void 0 ? void 0 : event.zalo_user_display_name;
        from_id = event === null || event === void 0 ? void 0 : (_event$recipient3 = event.recipient) === null || _event$recipient3 === void 0 ? void 0 : _event$recipient3.id;
        to_avatar = event === null || event === void 0 ? void 0 : event.zalo_oa_avatar;
        to_display_name = event === null || event === void 0 ? void 0 : event.zalo_oa_display_name;
        to_id = event === null || event === void 0 ? void 0 : (_event$sender3 = event.sender) === null || _event$sender3 === void 0 ? void 0 : _event$sender3.id;
        _style = styleFrom$1;
      }
      var newMessage = {
        response: {
          eventName: event === null || event === void 0 ? void 0 : event.event_name,
          payloads: [_extends({}, event === null || event === void 0 ? void 0 : (_event$message2 = event.message) === null || _event$message2 === void 0 ? void 0 : (_event$message2$attac = _event$message2.attachments) === null || _event$message2$attac === void 0 ? void 0 : (_event$message2$attac2 = _event$message2$attac[0]) === null || _event$message2$attac2 === void 0 ? void 0 : _event$message2$attac2.payload)]
        },
        from_avatar: from_avatar,
        from_display_name: from_display_name,
        from_id: from_id,
        message: event === null || event === void 0 ? void 0 : (_event$message3 = event.message) === null || _event$message3 === void 0 ? void 0 : _event$message3.text,
        message_id: event === null || event === void 0 ? void 0 : (_event$message4 = event.message) === null || _event$message4 === void 0 ? void 0 : _event$message4.msg_id,
        style: _style,
        time: event === null || event === void 0 ? void 0 : event.timestamp,
        to_avatar: to_avatar,
        to_display_name: to_display_name,
        to_id: to_id,
        type: type,
        url: url
      };
      setMessages([].concat(messages, [newMessage]));
      setIsChatSending(false);
    }
  };
  var handleChange = function handleChange(event) {
    var _event$target, _event$target2;
    console.log('files', (_event$target = event.target) === null || _event$target === void 0 ? void 0 : _event$target.files);
    setFiles(Array.from((_event$target2 = event.target) === null || _event$target2 === void 0 ? void 0 : _event$target2.files));
  };
  var removeFileItem = function removeFileItem(item, index) {
    files.splice(index, 1);
    setFiles([].concat(files));
  };
  return /*#__PURE__*/React__default.createElement("div", {
    style: _extends({
      flex: 1,
      display: 'flex',
      flexDirection: 'column',
      minWidth: 300,
      height: '100%'
    }, style)
  }, showChatHeader ? /*#__PURE__*/React__default.createElement("div", {
    style: {
      padding: 12,
      height: 64,
      width: '100%'
    },
    className: "box-shadow"
  }, /*#__PURE__*/React__default.createElement("div", {
    style: {
      display: 'inline-flex',
      alignItems: 'center'
    }
  }, /*#__PURE__*/React__default.createElement("img", {
    src: conversationDetail === null || conversationDetail === void 0 ? void 0 : conversationDetail.displayAvatar,
    style: {
      width: 40,
      height: 40,
      borderRadius: 20,
      objectFit: 'cover',
      backgroundColor: '#f1f1f1'
    }
  }), /*#__PURE__*/React__default.createElement("div", {
    style: {
      marginLeft: 12
    }
  }, /*#__PURE__*/React__default.createElement("div", null, conversationDetail === null || conversationDetail === void 0 ? void 0 : conversationDetail.displayName), /*#__PURE__*/React__default.createElement(Space, {
    size: 0,
    style: {
      marginTop: 4
    }
  }, tag === null || tag === void 0 ? void 0 : tag.map(function (e) {
    return /*#__PURE__*/React__default.createElement(Tag, {
      color: e === null || e === void 0 ? void 0 : e.color
    }, e === null || e === void 0 ? void 0 : e.name);
  }))))) : null, fetchingData && !(conversationDetailParams !== null && conversationDetailParams !== void 0 && conversationDetailParams.page) ? /*#__PURE__*/React__default.createElement("div", {
    style: {
      flex: 1,
      padding: 24
    }
  }, /*#__PURE__*/React__default.createElement(Skeleton, {
    loading: true,
    active: true,
    avatar: true
  }), /*#__PURE__*/React__default.createElement(Skeleton, {
    loading: true,
    active: true,
    avatar: true
  }), /*#__PURE__*/React__default.createElement(Skeleton, {
    loading: true,
    active: true,
    avatar: true
  })) : /*#__PURE__*/React__default.createElement(Fragment, null, /*#__PURE__*/React__default.createElement(MessagesRender, {
    ref: messagesRef,
    chatId: conversationDetail === null || conversationDetail === void 0 ? void 0 : conversationDetail.chatId,
    messages: messages,
    startReached: startReached,
    START_INDEX: startIndex,
    type: CONST.CONVERSATION_TYPE.ZALO,
    isChatSending: isChatSending,
    messageStyle: messageStyle
  }), isChatSending ? /*#__PURE__*/React__default.createElement("div", {
    style: {
      color: '#999',
      fontSize: 12,
      textAlign: 'center',
      padding: 4
    }
  }, "\u0110ang g\u1EEDi") : null, /*#__PURE__*/React__default.createElement("div", {
    style: {
      maxHeight: fileMaxHeight,
      overflowY: 'auto',
      borderTop: '1px solid #eee'
    }
  }, files === null || files === void 0 ? void 0 : files.map(function (e, i) {
    return /*#__PURE__*/React__default.createElement("div", {
      key: e === null || e === void 0 ? void 0 : e.name,
      className: styles$1['chat-file-item']
    }, /*#__PURE__*/React__default.createElement("div", {
      className: styles$1['chat-file-item-img']
    }, (e === null || e === void 0 ? void 0 : e.type.indexOf('image')) > -1 ? /*#__PURE__*/React__default.createElement(FileImageOutlined$2, null) : /*#__PURE__*/React__default.createElement(PaperClipOutlined$2, null)), /*#__PURE__*/React__default.createElement("div", {
      style: {
        flex: 1,
        marginLeft: 12
      }
    }, e === null || e === void 0 ? void 0 : e.name), /*#__PURE__*/React__default.createElement(CloseOutlined$2, {
      className: styles$1['chat-file-item-delete'],
      onClick: function onClick() {
        return removeFileItem(e, i);
      }
    }));
  })), /*#__PURE__*/React__default.createElement("div", {
    style: {
      padding: 12,
      display: 'flex',
      flexDirection: 'row',
      alignItems: 'flex-end'
    }
  }, /*#__PURE__*/React__default.createElement(Input.TextArea, {
    placeholder: "Nh\u1EADp n\u1ED9i dung",
    value: chatContent,
    onChange: function onChange(e) {
      var _e$target;
      return setChatContent(e === null || e === void 0 ? void 0 : (_e$target = e.target) === null || _e$target === void 0 ? void 0 : _e$target.value);
    },
    autoSize: {
      minRows: 1,
      maxRows: 6
    },
    style: {
      flex: 1
    }
  }), /*#__PURE__*/React__default.createElement(PaperClipOutlined$2, {
    style: {
      fontSize: 24,
      paddingLeft: 12,
      paddingBottom: 4,
      color: '#136DFB'
    },
    onClick: function onClick() {
      return fileInputRef.current.click();
    }
  }), /*#__PURE__*/React__default.createElement("input", {
    onChange: handleChange,
    multiple: true,
    ref: fileInputRef,
    type: "file",
    hidden: true
  }), /*#__PURE__*/React__default.createElement(SendOutlined$2, {
    style: {
      fontSize: 24,
      paddingLeft: 12,
      paddingBottom: 4,
      color: '#136DFB'
    },
    onClick: sendMessage
  }))));
};

var ExampleComponent1 = function ExampleComponent1(_ref) {
  var text = _ref.text;
  return /*#__PURE__*/React__default.createElement("div", {
    className: styles.test
  }, "Example Component: ", text);
};

export { CONST, ExampleComponent1, FbConversationDetail, FbConversations, ZaloConversationDetail, ZaloConversations };
//# sourceMappingURL=index.modern.js.map
